/*
 * Copyright (c) 2012-2015, Kosaku Nagasaka <nagasaka@main.h.kobe-u.ac.jp>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define SNAP_SUPD_T

#define SNAP_t supd_t
#define SNAP_init supd_init
#define SNAP_init2 supd_init2
#define SNAP_init_set(a,b) supd_init_set(a, b)
#define SNAP_clear supd_clear
#define SNAP_coef supd_coef
#define SNAP_coefp supd_coefp
#define SNAP_coefs supd_coefs
#define SNAP_lcoef supd_lcoef
#define SNAP_lcoefp supd_lcoefp
#define SNAP_size supd_size
#define SNAP_degree supd_degree
#define SNAP_set(a,b) supd_set(a, b)
#pragma GCC diagnostic ignored "-Wmaybe-uninitialized"
#define SNAP_set_base(a,b,c) supd_set_d(a, b, c)
#pragma GCC diagnostic warning "-Wmaybe-uninitialized"
#define SNAP_set_basecomplex(a,b,c) supd_set_dc(a, b, c)
#define SNAP_set_rbase(a,b,c) supd_set_rd(a, b, c)
#define SNAP_set_rbasecomplex(a,b,c) supd_set_rdc(a, b, c)
#define SNAP_set_z(a,b,c) supd_set_z(a, b, c)
#define SNAP_set_d(a,b,c) supd_set_d(a, b, c)
#define SNAP_set_rd(a,b,c) supd_set_rd(a, b, c)
#define SNAP_set_dc(a,b,c) supd_set_dc(a, b, c)
#define SNAP_set_rdc(a,b,c) supd_set_rdc(a, b, c)
#define SNAP_set_fr(a,b,c) supd_set_fr(a, b, c)
#define SNAP_set_rfr(a,b,c) supd_set_rfr(a, b, c)
#define SNAP_set_fc(a,b,c) supd_set_fc(a, b, c)
#define SNAP_set_rfc(a,b,c) supd_set_rfc(a, b, c)
#define SNAP_set_coef(a,b,c) supd_set_coef(a, b, c)
#define SNAP_set_coef_base(a,b,c) supd_set_coef(a, b, c)
#define SNAP_set_coef_d(a,b,c) supd_set_coef_d(a, b, c)
#define SNAP_set_str(a,b) supd_set_str(a, b)
#define SNAP_set_str_real(a,b,c) supd_set_str_real(a, b, c)
#define SNAP_set_str_imag(a,b,c) supd_set_str_imag(a, b, c)
#define SNAP_set_str_ppnumber(a,b,c) supd_set_str_ppnumber(a, b, c)
#define SNAP_set_str_number(a,b,c) supd_set_str_number(a, b, c)
#define SNAP_set_str_num(a,b,c) supd_set_str_num(a, b, c)
#define SNAP_set_str_term(a,b) supd_set_str_term(a, b)
#define SNAP_set_str_ppmonomial(a,b,c) supd_set_str_ppmonomial(a, b, c)
#define SNAP_set_str_monomial(a,b) supd_set_str_monomial(a, b)
#define SNAP_set_str_poly(a,b) supd_set_str_poly(a, b)
#define SNAP_set_str_polyall(a,b) supd_set_str_polyall(a, b)
#define SNAP_swap supd_swap
#define SNAP_2norm(a,b) (a=supd_2norm(b))
#define SNAP_inorm(a,b) (a=supd_inorm(b))
#define SNAP_self_neg(a) supd_self_neg(a)
#define SNAP_self_reversal supd_self_reversal
#define SNAP_add(a,b,c) supd_add(a, b, c)
#define SNAP_sub(a,b,c) supd_sub(a, b, c)
#define SNAP_mul(a,b,c) supd_mul(a, b, c)
#define SNAP_mul_traditional_nc(a,b,c) supd_mul_traditional_nc(a, b, c)
#define SNAP_mul_traditional(a,b,c) supd_mul_traditional(a, b, c)
#define SNAP_mul_karatsuba_main(a,b,c,d,e,f,g,h,i,j,k,l,m,n) supd_mul_karatsuba_main(a, b, c, d, e, f, g, h, i, j, k, l, m, n)
#define SNAP_mul_karatsuba_nc(a,b,c,d) supd_mul_karatsuba_nc(a, b, c, d)
#define SNAP_mul_karatsuba(a,b,c) supd_mul_karatsuba(a, b, c)
#define SNAP_mul_karatsuba_block_nc(a,b,c) supd_mul_karatsuba_block_nc(a, b, c)
#define SNAP_mul_karatsuba_block(a,b,c) supd_mul_karatsuba_block(a, b, c)
#define SNAP_mul_base(a,b,c) supd_mul_d(a, b, c)
#define SNAP_mul_basereal(a,b,c) supd_mul_d(a, b, c)
#define SNAP_mul_fr(a,b,c) supd_mul_fr(a, b, c)
#define SNAP_mul_si(a,b,c) supd_mul_si(a, b, c)
#define SNAP_mul_d(a,b,c) supd_mul_d(a, b, c)
#define SNAP_mul_dc(a,b,c) supd_mul_dc(a, b, c)
#define SNAP_div_qr_nc(a,b,c) supd_div_qr_nc(a, b, c)
#define SNAP_div_qr(a,b,c,d) supd_div_qr(a, b, c, d)
#define SNAP_lsdiv_q(a,b,c) supd_lsdiv_q(a, b, c)
#define SNAP_fftdiv_q(a,b,c) supd_fftdiv_q(a, b, c)
#define SNAP_div_base(a,b,c) supd_div_d(a, b, c)
#define SNAP_div_basereal(a,b,c) supd_div_d(a, b, c)
#define SNAP_div_fr(a,b,c) supd_div_fr(a, b, c)
#define SNAP_div_fc(a,b,c) supd_div_fc(a, b, c)
#define SNAP_div_d(a,b,c) supd_div_d(a, b, c)
#define SNAP_div_dc(a,b,c) supd_div_dc(a, b, c)
#define SNAP_randpoly(a,b,c,d,e) supd_randpoly(a, b, c, d)

#define SNAP_agcd_exqrgcd_rootsquaring supd_agcd_exqrgcd_rootsquaring
#define SNAP_agcd_exqrgcd_roughsplit supd_agcd_exqrgcd_roughsplit
#define SNAP_agcd_exqrgcd_split supd_agcd_exqrgcd_split
#define SNAP_agcd_exqrgcd_quicksort_uint_by_base_nc supd_agcd_exqrgcd_quicksort_uint_by_d_nc
#define SNAP_agcd_exqrgcd_quicksort_uint_by_base supd_agcd_exqrgcd_quicksort_uint_by_d
#define SNAP_agcd_exqrgcd_Qkthcolumn supd_agcd_exqrgcd_Qkthcolumn
#define SNAP_agcd_exqrgcd supd_agcd_exqrgcd
#define SNAP_agcd_exqrgcd_qrstep supd_agcd_exqrgcd_qrstep

#define SNAP_agcd_exqrgcd2 supd_agcd_exqrgcd2
#define SNAP_agcd_exqrgcd2_qrstep supd_agcd_exqrgcd2_qrstep

#define SNAP_agcd_qrgcd supd_agcd_qrgcd
#define SNAP_agcd_qrgcd_qrstep supd_agcd_qrgcd_qrstep

#define SNAP_agcd_qrgcd2 supd_agcd_qrgcd2
#define SNAP_agcd_qrgcd2_qrstep supd_agcd_qrgcd2_qrstep

#define SNAP_agcd_uvgcd supd_agcd_uvgcd
#pragma GCC diagnostic ignored "-Wmaybe-uninitialized"
#define SNAP_agcd_uvgcd_iteration_7_3(a,b,c,d,e) supd_agcd_uvgcd_iteration_7_3(a, b, c, d)
#pragma GCC diagnostic warning "-Wmaybe-uninitialized"
#define SNAP_agcd_uvgcd_solving_10_2(a,b,c,d,e,f) supd_agcd_uvgcd_solving_10_2(a, b, c, d, e, f)
#define SNAP_agcd_uvgcd_update(a,b,c,d,e,f,g) supd_agcd_uvgcd_update(a, b, c, d, e, f, g)
#define SNAP_agcd_uvgcd_iteration_9_2(a,b,c,d,e,f) supd_agcd_uvgcd_iteration_9_2(a, b, c, d, e, f)
#define SNAP_agcd_uvgcd2 supd_agcd_uvgcd2
#define SNAP_agcd_uvgcd_ex supd_agcd_uvgcd_ex
#define SNAP_agcd_uvgcd_solving_10_2_lsy(a,b,c,d,e,f) supd_agcd_uvgcd_solving_10_2_lsy(a, b, c, d, e, f)
#define SNAP_agcd_uvgcd_iteration_9_2_lsy(a,b,c,d,e,f) supd_agcd_uvgcd_iteration_9_2_lsy(a, b, c, d, e, f)
#define SNAP_agcd_uvgcdy_ex supd_agcd_uvgcdy_ex

#define SNAP_agcd_qrgcdfp supd_agcd_qrgcdfp
#define SNAP_agcd_qrgcdwp supd_agcd_qrgcdwp
#define SNAP_agcd_qrgcdwp_qrstep supd_agcd_qrgcdwp_qrstep
#define SNAP_agcd_exqrgcdfp supd_agcd_exqrgcdfp
#define SNAP_agcd_exqrgcdwp supd_agcd_exqrgcdwp
#define SNAP_agcd_exqrgcdwp_qrstep supd_agcd_exqrgcdwp_qrstep
#define SNAP_agcd_exqrgcdwp_split supd_agcd_exqrgcdwp_split

#define SNAP_agcd_uvgcdwp supd_agcd_uvgcdwp
#pragma GCC diagnostic ignored "-Wmaybe-uninitialized"
#define SNAP_agcd_uvgcdwp_iteration_7_3(a,b,c,d,e) supd_agcd_uvgcdwp_iteration_7_3(a, b, c, d)
#pragma GCC diagnostic warning "-Wmaybe-uninitialized"
#define SNAP_agcd_uvgcdwp_solving_10_2(a,b,c,d,e,f) supd_agcd_uvgcdwp_solving_10_2(a, b, c, d, e, f)
#define SNAP_agcd_uvgcdwp_update(a,b,c,d,e,f,g,h,i) supd_agcd_uvgcdwp_update(a, b, c, d, e, f, g, h, i)
#define SNAP_agcd_uvgcdwp_iteration_9_2(a,b,c,d,e,f) supd_agcd_uvgcdwp_iteration_9_2(a, b, c, d, e, f)

#define SNAP_agcd_fastgcd2 supd_agcd_fastgcd2
#define SNAP_agcd_fastgcd supd_agcd_fastgcd
#define SNAP_agcd_fastgcd_refine supd_agcd_fastgcd_refine
#define SNAP_agcd_fastgcd_modified_gko supd_agcd_fastgcd_modified_gko
#define SNAP_agcd_fastgcd_make_cauchy_generators supd_agcd_fastgcd_make_cauchy_generators
#define SNAP_agcd_fastgcd_make_sylvester_generators supd_agcd_fastgcd_make_sylvester_generators
#define SNAP_agcd_fastgcd_make_subresultant_generators supd_agcd_fastgcd_make_subresultant_generators
#define SNAP_agcd_fastgcd_make_jacobian_generators supd_agcd_fastgcd_make_jacobian_generators
#define SNAP_agcd_fastgcd_lcm supd_agcd_fastgcd_lcm
#define SNAP_agcd_fastgcd_make_trans_matrices supd_agcd_fastgcd_make_trans_matrices
#define SNAP_agcd_fastgcd_nullvector supd_agcd_fastgcd_nullvector
#define SNAP_agcd_fastgcd_linesearch supd_agcd_fastgcd_linesearch

#define SNAP_agcd_gpgcd supd_agcd_gpgcd
#define SNAP_agcd_gpgcd_construct_tildevectors supd_agcd_gpgcd_construct_tildevectors
#define SNAP_agcd_gpgcd_initial_cofactors supd_agcd_gpgcd_initial_cofactors
#define SNAP_agcd_gpgcd_subresultant_mapping_matrix_dsc supd_agcd_gpgcd_subresultant_mapping_matrix_dsc
#define SNAP_agcd_gpgcd_modified_newton supd_agcd_gpgcd_modified_newton
#define SNAP_agcd_gpgcd_Jacobian supd_agcd_gpgcd_Jacobian
#define SNAP_agcd_gpgcd_nabla supd_agcd_gpgcd_nabla
#define SNAP_agcd_gpgcd_const supd_agcd_gpgcd_const
#define SNAP_agcd_gpgcd_direction supd_agcd_gpgcd_direction
#define SNAP_agcd_gpgcd_update supd_agcd_gpgcd_update
#define SNAP_agcd_gpgcd_lsdiv supd_agcd_gpgcd_lsdiv
#define SNAP_agcd_gpgcd_pseudo_inverse_by_svd supd_agcd_gpgcd_pseudo_inverse_by_svd
#define SNAP_agcd_gpgcd_pseudo_inverse_by_tri supd_agcd_gpgcd_pseudo_inverse_by_tri
#define SNAP_agcd_gpgcd2 supd_agcd_gpgcd2
#define SNAP_agcd_gpgcd_initial_vector supd_agcd_gpgcd_initial_vector
#define SNAP_agcd_gpgcd_modified_newton2 supd_agcd_gpgcd_modified_newton2
#define SNAP_agcd_gpgcd_ex supd_agcd_gpgcd_ex
#define SNAP_agcd_gpgcd_modified_newton_ex supd_agcd_gpgcd_modified_newton_ex

#define SNAP_agcd_stlngcd supd_agcd_stlngcd
#define SNAP_agcd_stlngcd2 supd_agcd_stlngcd2
#define SNAP_agcd_stlngcd2_convolution_like_matrix supd_agcd_stlngcd2_convolution_like_matrix
#define SNAP_agcd_stlngcd2_init_Ak supd_agcd_stlngcd2_init_Ak
#define SNAP_agcd_stlngcd2_update_Ak supd_agcd_stlngcd2_update_Ak
#define SNAP_agcd_stlngcd2_convolution_like_matrix_YPk supd_agcd_stlngcd2_convolution_like_matrix_YPk
#define SNAP_agcd_stlngcd_ex supd_agcd_stlngcd_ex
#define SNAP_agcd_stlngcd2_ex supd_agcd_stlngcd2_ex
#define SNAP_agcd_stlngcd2x_ex supd_agcd_stlngcd2x_ex

#define SNAP_agcd_ghlgcd supd_agcd_ghlgcd
#define SNAP_agcd_ghlgcd_ex supd_agcd_ghlgcd_ex

#define SNAPBASE_t double
#define SNAPBASE_mpfr_rnd_t mpfr_rnd_t
#define SNAPBASE_mpc_rnd_t mpc_rnd_t
// #define SNAPBASE_RNDN MPFR_RNDN
#define SNAPBASE_init(a) (a=0.0)
#define SNAPBASE_clear(a) {}
#define SNAPBASE_init_set(a,b) (a=(b))
#define SNAPBASE_init_set_ui(a,b) (a=(double)(b))
#define SNAPBASE_init_set_d(a,b) (a=(double)(b))
#define SNAPBASE_set(a,b) (a=(b))
#define SNAPBASE_set_basereal(a,b) (a=(b))
#define SNAPBASE_set_basecomplex(a,b) (a=creal(b))
#define SNAPBASE_set_ui(a,b) (a=(double)(b))
#define SNAPBASE_set_si(a,b) (a=(double)(b))
#define SNAPBASE_set_z(a,b) (a=mpz_get_d(b))
#define SNAPBASE_set_fr(a,b) (a=mpfr_get_d(b,SNAPLIB_MPFR_RND))
#define SNAPBASE_set_fc(a,b) (a=(dcomplex) (mpfr_get_d(mpc_realref(b),MPC_RND_RE(SNAPLIB_MPC_RND))))
#define SNAPBASE_set_d(a,b) (a=(b))
#define SNAPBASE_set_dc(a,b) (a=(double)creal(b))
#define SNAPBASE_set_str(a,b,c) (a=strtod(b,NULL))
// #define SNAPBASE_get_str(a,b,c) mpfr_get_str(a, b, c)
// We assume that round mode is ROUND TO THE NEAREST
#define SNAPBASE_get_ui_rnd(a) (lround(a))
#define SNAPBASE_sgn(a) (a)
#define SNAPBASE_zeroq(a) ((a) == (double)0.0)
#define SNAPBASE_nan_p(a) (isnan(a))
#define SNAPBASE_abs(a,b) (a=fabs(b))
#define SNAPBASE_normsquare(a,b) (a=(b)*(b))
#define SNAPBASE_cmp(a,b) ((a)-(b))
#define SNAPBASE_cmpabs(a,b) (fabs(a)-fabs(b))
#define SNAPBASE_cmp_ui(a,b) ((double)(a)-(b))
#define SNAPBASE_neg(a,b) (a=-(b))
#define SNAPBASE_neg_basereal(a,b) (a=-(b))
#define SNAPBASE_rec(a,b) (a=(1/b))
#define SNAPBASE_swap(a,b) do{double SNAP_tmp;SNAP_tmp=(a);a=(b);b=SNAP_tmp;}while(0)
#define SNAPBASE_add(a,b,c) (a=(b)+(c))
#define SNAPBASE_add_d(a,b,c) (a=(b)+(c))
#define SNAPBASE_add_ui(a,b,c) (a=(b)+((double)(c)))
#define SNAPBASE_sub(a,b,c) (a=(b)-(c))
#define SNAPBASE_sub_basecomplex(a,b,c) (a=(b)-creal(c))
#define SNAPBASE_sub_d(a,b,c) (a=(b)-(c))
#define SNAPBASE_sub_ui(a,b,c) (a=(b)-((double)(c)))
#define SNAPBASE_addmul(a,b,c) (a+=(b)*(c))
#define SNAPBASE_addmul_ui_basecomplex(a,b,c) (a+=((double)b)*(creal(c)))
#define SNAPBASE_submul_basecomplex_basecomplex(a,b,c) (a-=creal((b)*(c)))
#define SNAPBASE_mul(a,b,c) (a=(b)*(c))
#define SNAPBASE_mul_base(a,b,c) (a=(b)*(c))
#define SNAPBASE_mul_basereal(a,b,c) (a=(b)*(c))
#define SNAPBASE_mul_d(a,b,c) (a=(b)*(c))
#define SNAPBASE_mul_dc(a,b,c) (a=(b)*((double)creal(c)))
#define SNAPBASE_mul_ui(a,b,c) (a=(b)*((double)(c)))
#define SNAPBASE_mul_ui_basecomplex(a,b,c) (a=((double)b)*(creal(c)))
#define SNAPBASE_mul_si(a,b,c) (a=(b)*((double)(c)))
#define SNAPBASE_mul_fr(a,b,c) (a=(b)*mpfr_get_d(c,SNAPLIB_MPFR_RND))
#define SNAPBASE_div(a,b,c) (a=(b)/(c))
#define SNAPBASE_div_basereal(a,b,c) (a=(b)/(c))
#define SNAPBASE_div_fr(a,b,c) (a=(b)/mpfr_get_d(c,SNAPLIB_MPFR_RND))
#define SNAPBASE_div_fc(a,b,c) (a=(b)/mpfr_get_d(mpc_realref(c),MPC_RND_RE(SNAPLIB_MPC_RND)))
#define SNAPBASE_div_d(a,b,c) (a=(b)/(c))
#define SNAPBASE_div_dc(a,b,c) (a=(b)/(creal(c)))
#define SNAPBASE_div_ui(a,b,c) (a=(b)/((double)(c)))
#define SNAPBASE_div_si(a,b,c) (a=(b)/((double)(c)))
#define SNAPBASE_sqrt(a,b) (a=sqrt(b))
#define SNAPBASE_sqrt_ui(a,b) (a=sqrt((double)(b)))
#define SNAPBASE_urandom(a,b) (a=((double) rand()/((double)RAND_MAX+1)))

#define SNAPBASEREAL_t SNAPBASE_t
#define SNAPBASEREAL_mpfr_rnd_t SNAPBASE_mpfr_rnd_t
#define SNAPBASEREAL_init SNAPBASE_init
#define SNAPBASEREAL_clear SNAPBASE_clear
#define SNAPBASEREAL_init_set SNAPBASE_init_set
#define SNAPBASEREAL_init_set_ui SNAPBASE_init_set_ui
#define SNAPBASEREAL_init_set_d SNAPBASE_init_set_d
#define SNAPBASEREAL_set SNAPBASE_set
#define SNAPBASEREAL_set_basecomplex(a,b) (a=creal(b))
#define SNAPBASEREAL_set_ui SNAPBASE_set_ui
#define SNAPBASEREAL_set_si SNAPBASE_set_si
#define SNAPBASEREAL_set_z SNAPBASE_set_z
#define SNAPBASEREAL_set_fr SNAPBASE_set_fr
#define SNAPBASEREAL_set_d SNAPBASE_set_d
#define SNAPBASEREAL_set_dc SNAPBASE_set_dc
#define SNAPBASEREAL_set_str SNAPBASE_set_str
#define SNAPBASEREAL_get_ui_rnd SNAPBASE_get_ui_rnd
#define SNAPBASEREAL_sgn SNAPBASE_sgn
#define SNAPBASEREAL_zeroq SNAPBASE_zeroq
#define SNAPBASEREAL_nan_p SNAPBASE_nan_p
#define SNAPBASEREAL_abs SNAPBASE_abs
#define SNAPBASEREAL_cmp SNAPBASE_cmp
#define SNAPBASEREAL_cmpabs SNAPBASE_cmpabs
#define SNAPBASEREAL_cmp_ui SNAPBASE_cmp_ui
#define SNAPBASEREAL_neg SNAPBASE_neg
#define SNAPBASEREAL_rec SNAPBASE_rec
#define SNAPBASEREAL_swap SNAPBASE_swap
#define SNAPBASEREAL_add SNAPBASE_add
#define SNAPBASEREAL_add_d SNAPBASE_add_d
#define SNAPBASEREAL_sub SNAPBASE_sub
#define SNAPBASEREAL_sub_d SNAPBASE_sub_d
#define SNAPBASEREAL_sub_ui SNAPBASE_sub_ui
#define SNAPBASEREAL_addmul SNAPBASE_addmul
#define SNAPBASEREAL_addmul_ui_basecomplex SNAPBASE_addmul_ui_basecomplex
#define SNAPBASEREAL_mul SNAPBASE_mul
#define SNAPBASEREAL_mul_d SNAPBASE_mul_d
#define SNAPBASEREAL_mul_dc SNAPBASE_mul_dc
#define SNAPBASEREAL_mul_ui SNAPBASE_mul_ui
#define SNAPBASEREAL_mul_basereal SNAPBASE_mul_basereal
#define SNAPBASEREAL_mul_ui_basecomplex SNAPBASE_mul_ui_basecomplex
#define SNAPBASEREAL_mul_si SNAPBASE_mul_si
#define SNAPBASEREAL_mul_fr SNAPBASE_mul_fr
#define SNAPBASEREAL_div SNAPBASE_div
#define SNAPBASEREAL_div_fr SNAPBASE_div_fr
#define SNAPBASEREAL_div_fc SNAPBASE_div_fc
#define SNAPBASEREAL_div_d SNAPBASE_div_d
#define SNAPBASEREAL_div_dc SNAPBASE_div_dc
#define SNAPBASEREAL_div_ui SNAPBASE_div_ui
#define SNAPBASEREAL_div_si SNAPBASE_div_si
#define SNAPBASEREAL_sqrt SNAPBASE_sqrt
#define SNAPBASEREAL_sqrt_ui SNAPBASE_sqrt_ui
#define SNAPBASEREAL_urandom SNAPBASE_urandom

// typedef double complex dcomplex;
#define SNAPBASECOMPLEX_t dcomplex
#define SNAPBASECOMPLEX_init(a) (a=0.0)
#define SNAPBASECOMPLEX_clear(a) {}
#define SNAPBASECOMPLEX_init_set(a,b) (a=(b))
#define SNAPBASECOMPLEX_init_set_ui(a,b) (a=(dcomplex)(b))
#define SNAPBASECOMPLEX_init_set_si(a,b) (a=(dcomplex)(b))
#define SNAPBASECOMPLEX_init_set_d(a,b) (a=(dcomplex)(b))
#define SNAPBASECOMPLEX_set(a,b) (a=(b))
#define SNAPBASECOMPLEX_set_base(a,b) (a=(dcomplex)(b))
#define SNAPBASECOMPLEX_set_basereal(a,b) (a=(dcomplex)(b))
#define SNAPBASECOMPLEX_set_ui(a,b) (a=(dcomplex)(b))
#define SNAPBASECOMPLEX_set_si(a,b) (a=(dcomplex)(b))
#define SNAPBASECOMPLEX_set_z(a,b) (a=(dcomplex) mpz_get_d(b))
#define SNAPBASECOMPLEX_set_fr(a,b) (a=(dcomplex) mpfr_get_d(b,SNAPLIB_MPFR_RND))
#define SNAPBASECOMPLEX_set_fc(a,b) (a=(dcomplex) (mpfr_get_d(mpc_realref(b),MPC_RND_RE(SNAPLIB_MPC_RND))+(mpfr_get_d(mpc_imagref(b),MPC_RND_IM(SNAPLIB_MPC_RND)))*_Complex_I))
#define SNAPBASECOMPLEX_set_d(a,b) (a=(dcomplex)(b))
#define SNAPBASECOMPLEX_set_dc(a,b) (a=(b))
#define SNAPBASECOMPLEX_set_str(a,b,c) (a=(dcomplex)strtod(b,NULL))
#define SNAPBASECOMPLEX_zeroq(a) ((a) == (dcomplex)0.0)
#define SNAPBASECOMPLEX_nan_p(a) (isnan(a))
#define SNAPBASECOMPLEX_abs(a,b) (a=cabs(b))
#define SNAPBASECOMPLEX_cmp(a,b) ((a)-(b))
#define SNAPBASECOMPLEX_cmpabs(a,b) (cabs(a)-cabs(b))
#define SNAPBASECOMPLEX_cmpabs_basereal(a,b) (cabs(a)-fabs(b))
#define SNAPBASECOMPLEX_cmp_ui(a,b) ((dcomplex)(a)-(b))
#define SNAPBASECOMPLEX_real(a) creal(a)
#define SNAPBASECOMPLEX_imag(a) cimag(a)
#define SNAPBASECOMPLEX_conj(a,b) (a=conj(b))
#define SNAPBASECOMPLEX_conj_base(a,b) (a=(dcomplex)(b))
#define SNAPBASECOMPLEX_neg(a,b) (a=-(b))
#define SNAPBASECOMPLEX_neg_base(a,b) (a=-((dcomplex)(b)))
#define SNAPBASECOMPLEX_neg_basereal(a,b) (a=-((dcomplex)(b)))
#define SNAPBASECOMPLEX_rec(a,b) (a=(1/b))
#define SNAPBASECOMPLEX_swap(a,b) do{dcomplex SNAP_tmp;SNAP_tmp=(a);a=(b);b=SNAP_tmp;}while(0)
#define SNAPBASECOMPLEX_add(a,b,c) (a=(b)+(c))
#define SNAPBASECOMPLEX_add_base(a,b,c) (a=(b)+(dcomplex)(c))
#define SNAPBASECOMPLEX_add_d(a,b,c) (a=(b)+(dcomplex)(c))
#define SNAPBASECOMPLEX_sub(a,b,c) (a=(b)-(c))
#define SNAPBASECOMPLEX_sub_base(a,b,c) (a=(b)-(dcomplex)(c))
#define SNAPBASECOMPLEX_sub_d(a,b,c) (a=(b)-(dcomplex)(c))
#define SNAPBASECOMPLEX_sub_dc(a,b,c) (a=(b)-(c))
#define SNAPBASECOMPLEX_addmul(a,b,c) (a+=(b)*(c))
#define SNAPBASECOMPLEX_submul(a,b,c) (a-=(b)*(c))
#define SNAPBASECOMPLEX_mul(a,b,c) (a=(b)*(c))
#define SNAPBASECOMPLEX_mul_base(a,b,c) (a=(b)*((dcomplex)(c)))
#define SNAPBASECOMPLEX_mul_basereal(a,b,c) (a=(b)*((dcomplex)(c)))
#define SNAPBASECOMPLEX_mul_d(a,b,c) (a=(b)*((dcomplex)(c)))
#define SNAPBASECOMPLEX_mul_dc(a,b,c) (a=(b)*(c))
#define SNAPBASECOMPLEX_mul_ui(a,b,c) (a=(b)*((dcomplex)(c)))
#define SNAPBASECOMPLEX_mul_si(a,b,c) (a=(b)*((dcomplex)(c)))
#define SNAPBASECOMPLEX_mul_fr(a,b,c) (a=(b)*((dcomplex)mpfr_get_d(c,SNAPLIB_MPFR_RND)))
#define SNAPBASECOMPLEX_div(a,b,c) (a=(b)/(c))
#define SNAPBASECOMPLEX_div_basereal(a,b,c) (a=(b)/((dcomplex)(c)))
#define SNAPBASECOMPLEX_div_fr(a,b,c) (a=(b)/((dcomplex)mpfr_get_d(c,SNAPLIB_MPFR_RND)))
#define SNAPBASECOMPLEX_div_fc(a,b,c) (a=(b)/((dcomplex)mpc_get_dc(c,SNAPLIB_MPC_RND)))
#define SNAPBASECOMPLEX_div_d(a,b,c) (a=(b)/((dcomplex)(c)))
#define SNAPBASECOMPLEX_div_dc(a,b,c) (a=(b)/(c))
#define SNAPBASECOMPLEX_div_ui(a,b,c) (a=(b)/((dcomplex)(c)))
#define SNAPBASECOMPLEX_div_si(a,b,c) (a=(b)/((dcomplex)(c)))
#define SNAPBASECOMPLEX_sqrt(a,b) (a=csqrt(b))
#define SNAPBASECOMPLEX_sqrt_ui(a,b) (a=(dcomplex)sqrt((double)(b)))
#define SNAPBASECOMPLEX_urandom(a,b) (a=((double) rand()/((double)RAND_MAX+1))+((double) rand()/((double)RAND_MAX+1))*_Complex_I)

#define SNAPMTX_t sdmd_t
#define SNAPMTX_init sdmd_init
#define SNAPMTX_init2 sdmd_init2
#define SNAPMTX_reinit2 sdmd_reinit2
#define SNAPMTX_reinit3 sdmd_reinit3
#define SNAPMTX_realloc sdmd_realloc
#define SNAPMTX_clear sdmd_clear
#define SNAPMTX_swap sdmd_swap
#define SNAPMTX_subresultant_mapping_matrix_asc(a,b,c,d) sdmd_subresultant_mapping_matrix_asc(a, b, c, d)
#define SNAPMTX_subresultant_mapping_matrix_dsc(a,b,c,d) sdmd_subresultant_mapping_matrix_dsc(a, b, c, d)
#define SNAPMTX_subresultant_mapping_matrix_transpose(a,b,c,d) sdmd_subresultant_mapping_matrix_transpose(a, b, c, d)
#define SNAPMTX_subresultant_mapping_matrix_transpose_column_major(a,b,c,d) sdmd_subresultant_mapping_matrix_transpose_column_major(a, b, c, d)
#define SNAPMTX_convolution_matrix(a,b,c) sdmd_convolution_matrix(a, b, c)
#define SNAPMTX_convolution_matrix_column_major(a,b,c) sdmd_convolution_matrix_column_major(a, b, c)
#define SNAPMTX_convolution_matrix_zerofill(a,b,c) sdmd_convolution_matrix_zerofill(a, b, c)
#define SNAPMTX_sylvester_matrix_transpose(a,b,c) sdmd_sylvester_matrix_transpose(a, b, c)
#define SNAPMTX_rows sdmd_rows
#define SNAPMTX_rsize sdmd_rsize
#define SNAPMTX_cols sdmd_cols
#define SNAPMTX_csize sdmd_csize
#define SNAPMTX_elem sdmd_elem
#define SNAPMTX_elem_column_major sdmd_elem_column_major
#define SNAPMTX_elems sdmd_elems
#define SNAPMTX_elemp sdmd_elemp
#define SNAPMTX_elemp_column_major sdmd_elemp_column_major

#define SNAPMTXREAL_t sdmd_t
#define SNAPMTXREAL_init sdmd_init
#define SNAPMTXREAL_init2 sdmd_init2
#define SNAPMTXREAL_reinit2 sdmd_reinit2
#define SNAPMTXREAL_reinit3 sdmd_reinit3
#define SNAPMTXREAL_realloc sdmd_realloc
#define SNAPMTXREAL_clear sdmd_clear
#define SNAPMTXREAL_swap sdmd_swap
#define SNAPMTXREAL_rows sdmd_rows
#define SNAPMTXREAL_rsize sdmd_rsize
#define SNAPMTXREAL_cols sdmd_cols
#define SNAPMTXREAL_csize sdmd_csize
#define SNAPMTXREAL_elem sdmd_elem
#define SNAPMTXREAL_elem_column_major sdmd_elem_column_major
#define SNAPMTXREAL_elems sdmd_elems
#define SNAPMTXREAL_elemp sdmd_elemp
#define SNAPMTXREAL_elemp_column_major sdmd_elemp_column_major

#define SNAPMTXCOMPLEX_t sdmdc_t
#define SNAPMTXCOMPLEX_init sdmdc_init
#define SNAPMTXCOMPLEX_init2 sdmdc_init2
#define SNAPMTXCOMPLEX_reinit2 sdmdc_reinit2
#define SNAPMTXCOMPLEX_reinit3 sdmdc_reinit3
#define SNAPMTXCOMPLEX_realloc sdmdc_realloc
#define SNAPMTXCOMPLEX_clear sdmdc_clear
#define SNAPMTXCOMPLEX_swap sdmdc_swap
#define SNAPMTXCOMPLEX_rows sdmdc_rows
#define SNAPMTXCOMPLEX_rsize sdmdc_rsize
#define SNAPMTXCOMPLEX_cols sdmdc_cols
#define SNAPMTXCOMPLEX_csize sdmdc_csize
#define SNAPMTXCOMPLEX_elem sdmdc_elem
#define SNAPMTXCOMPLEX_elem_column_major sdmdc_elem_column_major
#define SNAPMTXCOMPLEX_elems sdmdc_elems
#define SNAPMTXCOMPLEX_elemp sdmdc_elemp
#define SNAPMTXCOMPLEX_elemp_column_major sdmdc_elemp_column_major

// compatiblity for BLAS and MBLAS
#define SNAPMTX_BLAS_nrm2(a,b,c,d) (a=cblas_dnrm2(b, c, d))
#define SNAPMTXREAL_BLAS_nrm2(a,b,c,d) (a=cblas_dnrm2(b, c, d))
#define SNAPMTX_BLAS_dot(a,b,c,d,e,f) (a=cblas_ddot(b, c, d, e, f))
#define SNAPMTXREAL_BLAS_dot(a,b,c,d,e,f) (a=cblas_ddot(b, c, d, e, f))
#define SNAPMTX_BLAS_dotc(a,b,c,d,e,f) (a=cblas_ddot(b, c, d, e, f))
#define SNAPMTXCOMPLEX_BLAS_nrm2(a,b,c,d) (a=cblas_dznrm2(b, c, d))
#define SNAPMTXCOMPLEX_BLAS_dotc(a,b,c,d,e,f) (cblas_zdotc_sub(b,c,d,e,f,&a))
#define SNAPMTXCOMPLEX_BLAS_dotu(a,b,c,d,e,f) (cblas_zdotu_sub(b,c,d,e,f,&a))
#define SNAPMTXCOMPLEX_BLAS_swap(a,b,c,d,e) (cblas_zswap(a,b,c,d,e))
#define SNAPMTXREAL_BLAS_scal(a,b,c,d) (cblas_dscal(a,b,c,d))
#define SNAP_gelsy snap_lapack_dgelsy_givens
