/*
 * Copyright (c) 2012-2015, Kosaku Nagasaka <nagasaka@main.h.kobe-u.ac.jp>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define SNAP_SUPDC_T

#define SNAP_t supdc_t
#define SNAP_init supdc_init
#define SNAP_init2 supdc_init2
#define SNAP_init_set(a,b) supdc_init_set(a, b)
#define SNAP_clear supdc_clear
#define SNAP_coef supdc_coef
#define SNAP_coefp supdc_coefp
#define SNAP_coefs supdc_coefs
#define SNAP_lcoef supdc_lcoef
#define SNAP_lcoefp supdc_lcoefp
#define SNAP_size supdc_size
#define SNAP_degree supdc_degree
#define SNAP_set(a,b) supdc_set(a, b)
#pragma GCC diagnostic ignored "-Wmaybe-uninitialized"
#define SNAP_set_base(a,b,c) supdc_set_dc(a, b, c)
#pragma GCC diagnostic warning "-Wmaybe-uninitialized"
#define SNAP_set_basecomplex(a,b,c) supdc_set_dc(a, b, c)
#define SNAP_set_rbase(a,b,c) supdc_set_rdc(a, b, c)
#define SNAP_set_rbasecomplex(a,b,c) supdc_set_rdc(a, b, c)
#define SNAP_set_z(a,b,c) supdc_set_z(a, b, c)
#define SNAP_set_d(a,b,c) supdc_set_d(a, b, c)
#define SNAP_set_rd(a,b,c) supdc_set_rd(a, b, c)
#define SNAP_set_dc(a,b,c) supdc_set_dc(a, b, c)
#define SNAP_set_rdc(a,b,c) supdc_set_rdc(a, b, c)
#define SNAP_set_fr(a,b,c) supdc_set_fr(a, b, c)
#define SNAP_set_rfr(a,b,c) supdc_set_rfr(a, b, c)
#define SNAP_set_fc(a,b,c) supdc_set_fc(a, b, c)
#define SNAP_set_rfc(a,b,c) supdc_set_rfc(a, b, c)
#define SNAP_set_coef(a,b,c) supdc_set_coef(a, b, c)
#define SNAP_set_coef_base(a,b,c) supd_set_coef(a, b, c)
#define SNAP_set_coef_d(a,b,c) supdc_set_coef_d(a, b, c)
#define SNAP_set_str(a,b) supdc_set_str(a, b)
#define SNAP_set_str_real(a,b,c) supdc_set_str_real(a, b, c)
#define SNAP_set_str_imag(a,b,c) supdc_set_str_imag(a, b, c)
#define SNAP_set_str_ppnumber(a,b,c) supdc_set_str_ppnumber(a, b, c)
#define SNAP_set_str_number(a,b,c) supdc_set_str_number(a, b, c)
#define SNAP_set_str_num(a,b,c) supdc_set_str_num(a, b, c)
#define SNAP_set_str_term(a,b) supdc_set_str_term(a, b)
#define SNAP_set_str_ppmonomial(a,b,c) supdc_set_str_ppmonomial(a, b, c)
#define SNAP_set_str_monomial(a,b) supdc_set_str_monomial(a, b)
#define SNAP_set_str_poly(a,b) supdc_set_str_poly(a, b)
#define SNAP_set_str_polyall(a,b) supdc_set_str_polyall(a, b)
#define SNAP_swap supdc_swap
#define SNAP_2norm(a,b) (a=supdc_2norm(b))
#define SNAP_inorm(a,b) (a=supdc_inorm(b))
#define SNAP_self_neg(a) supdc_self_neg(a)
#define SNAP_self_reversal supdc_self_reversal
#define SNAP_add(a,b,c) supdc_add(a, b, c)
#define SNAP_sub(a,b,c) supdc_sub(a, b, c)
#define SNAP_mul(a,b,c) supdc_mul(a, b, c)
#define SNAP_mul_traditional_nc(a,b,c) supdc_mul_traditional_nc(a, b, c)
#define SNAP_mul_traditional(a,b,c) supdc_mul_traditional(a, b, c)
#define SNAP_mul_karatsuba_main(a,b,c,d,e,f,g,h,i,j,k,l,m,n) supdc_mul_karatsuba_main(a, b, c, d, e, f, g, h, i, j, k, l, m, n)
#define SNAP_mul_karatsuba_nc(a,b,c,d) supdc_mul_karatsuba_nc(a, b, c, d)
#define SNAP_mul_karatsuba(a,b,c) supdc_mul_karatsuba(a, b, c)
#define SNAP_mul_karatsuba_block_nc(a,b,c) supdc_mul_karatsuba_block_nc(a, b, c)
#define SNAP_mul_karatsuba_block(a,b,c) supdc_mul_karatsuba_block(a, b, c)
#define SNAP_mul_base(a,b,c) supdc_mul_dc(a, b, c)
#define SNAP_mul_basereal(a,b,c) supdc_mul_d(a, b, c)
#define SNAP_mul_fr(a,b,c) supdc_mul_fr(a, b, c)
#define SNAP_mul_si(a,b,c) supdc_mul_si(a, b, c)
#define SNAP_mul_d(a,b,c) supdc_mul_d(a, b, c)
#define SNAP_mul_dc(a,b,c) supdc_mul_dc(a, b, c)
#define SNAP_div_qr_nc(a,b,c) supdc_div_qr_nc(a, b, c)
#define SNAP_div_qr(a,b,c,d) supdc_div_qr(a, b, c, d)
#define SNAP_lsdiv_q(a,b,c) supdc_lsdiv_q(a, b, c)
#define SNAP_fftdiv_q(a,b,c) supdc_fftdiv_q(a, b, c)
#define SNAP_div_base(a,b,c) supdc_div_dc(a, b, c)
#define SNAP_div_basereal(a,b,c) supdc_div_d(a, b, c)
#define SNAP_div_fr(a,b,c) supdc_div_fr(a, b, c)
#define SNAP_div_fc(a,b,c) supdc_div_fc(a, b, c)
#define SNAP_div_d(a,b,c) supdc_div_d(a, b, c)
#define SNAP_div_dc(a,b,c) supdc_div_dc(a, b, c)
#define SNAP_randpoly(a,b,c,d,e) supdc_randpoly(a, b, c, d)

#define SNAP_agcd_exqrgcd_rootsquaring supdc_agcd_exqrgcd_rootsquaring
#define SNAP_agcd_exqrgcd_roughsplit supdc_agcd_exqrgcd_roughsplit
#define SNAP_agcd_exqrgcd_split supdc_agcd_exqrgcd_split
#define SNAP_agcd_exqrgcd_quicksort_uint_by_base_nc supdc_agcd_exqrgcd_quicksort_uint_by_dc_nc
#define SNAP_agcd_exqrgcd_quicksort_uint_by_base supdc_agcd_exqrgcd_quicksort_uint_by_dc
#define SNAP_agcd_exqrgcd_Qkthcolumn supdc_agcd_exqrgcd_Qkthcolumn
#define SNAP_agcd_exqrgcd supdc_agcd_exqrgcd
#define SNAP_agcd_exqrgcd_qrstep supdc_agcd_exqrgcd_qrstep

#define SNAP_agcd_exqrgcd2 supdc_agcd_exqrgcd2
#define SNAP_agcd_exqrgcd2_qrstep supdc_agcd_exqrgcd2_qrstep

#define SNAP_agcd_exqrgcdwc_rootsquaring supdc_agcd_exqrgcdwc_rootsquaring
#define SNAP_agcd_exqrgcdwc_roughsplit supdc_agcd_exqrgcdwc_roughsplit
#define SNAP_agcd_exqrgcdwc_split supdc_agcd_exqrgcdwc_split
#define SNAP_agcd_exqrgcdwc_quicksort_uint_by_base_nc supdc_agcd_exqrgcdwc_quicksort_uint_by_dc_nc
#define SNAP_agcd_exqrgcdwc_quicksort_uint_by_base supdc_agcd_exqrgcdwc_quicksort_uint_by_dc
#define SNAP_agcd_exqrgcdwc supdc_agcd_exqrgcdwc
#define SNAP_agcd_exqrgcdwc_qrstep supdc_agcd_exqrgcdwc_qrstep

#define SNAP_agcd_qrgcd supdc_agcd_qrgcd
#define SNAP_agcd_qrgcd_qrstep supdc_agcd_qrgcd_qrstep

#define SNAP_agcd_qrgcd2 supdc_agcd_qrgcd2
#define SNAP_agcd_qrgcd2_qrstep supdc_agcd_qrgcd2_qrstep

#define SNAP_agcd_uvgcd supdc_agcd_uvgcd
#pragma GCC diagnostic ignored "-Wmaybe-uninitialized"
#define SNAP_agcd_uvgcd_iteration_7_3(a,b,c,d,e) supdc_agcd_uvgcd_iteration_7_3(a, b, c, d)
#pragma GCC diagnostic warning "-Wmaybe-uninitialized"
#define SNAP_agcd_uvgcd_solving_10_2(a,b,c,d,e,f) supdc_agcd_uvgcd_solving_10_2(a, b, c, d, e, f)
#define SNAP_agcd_uvgcd_update(a,b,c,d,e,f,g) supdc_agcd_uvgcd_update(a, b, c, d, e, f, g)
#define SNAP_agcd_uvgcd_iteration_9_2(a,b,c,d,e,f) supdc_agcd_uvgcd_iteration_9_2(a, b, c, d, e, f)
#define SNAP_agcd_uvgcd2 supdc_agcd_uvgcd2
#define SNAP_agcd_uvgcd_ex supdc_agcd_uvgcd_ex
#define SNAP_agcd_uvgcd_solving_10_2_lsy(a,b,c,d,e,f) supdc_agcd_uvgcd_solving_10_2_lsy(a, b, c, d, e, f)
#define SNAP_agcd_uvgcd_iteration_9_2_lsy(a,b,c,d,e,f) supdc_agcd_uvgcd_iteration_9_2_lsy(a, b, c, d, e, f)
#define SNAP_agcd_uvgcdy_ex supdc_agcd_uvgcdy_ex

#define SNAP_agcd_qrgcdfp supdc_agcd_qrgcdfp
#define SNAP_agcd_qrgcdwp supdc_agcd_qrgcdwp
#define SNAP_agcd_qrgcdwp_qrstep supdc_agcd_qrgcdwp_qrstep
#define SNAP_agcd_exqrgcdfp supdc_agcd_exqrgcdfp
#define SNAP_agcd_exqrgcdwp supdc_agcd_exqrgcdwp
#define SNAP_agcd_exqrgcdwp_qrstep supdc_agcd_exqrgcdwp_qrstep
#define SNAP_agcd_exqrgcdwp_split supdc_agcd_exqrgcdwp_split

#define SNAP_agcd_uvgcdwp supdc_agcd_uvgcdwp
#define SNAP_agcd_uvgcdwp_iteration_7_3(a,b,c,d,e) supdc_agcd_uvgcdwp_iteration_7_3(a, b, c, d)
#define SNAP_agcd_uvgcdwp_solving_10_2(a,b,c,d,e,f) supdc_agcd_uvgcdwp_solving_10_2(a, b, c, d, e, f)
#define SNAP_agcd_uvgcdwp_update(a,b,c,d,e,f,g,h,i) supdc_agcd_uvgcdwp_update(a, b, c, d, e, f, g, h, i)
#define SNAP_agcd_uvgcdwp_iteration_9_2(a,b,c,d,e,f) supdc_agcd_uvgcdwp_iteration_9_2(a, b, c, d, e, f)

#define SNAP_agcd_fastgcd2 supdc_agcd_fastgcd2
#define SNAP_agcd_fastgcd supdc_agcd_fastgcd
#define SNAP_agcd_fastgcd_refine supdc_agcd_fastgcd_refine
#define SNAP_agcd_fastgcd_modified_gko supdc_agcd_fastgcd_modified_gko
#define SNAP_agcd_fastgcd_make_cauchy_generators supdc_agcd_fastgcd_make_cauchy_generators
#define SNAP_agcd_fastgcd_make_sylvester_generators supdc_agcd_fastgcd_make_sylvester_generators
#define SNAP_agcd_fastgcd_make_subresultant_generators supdc_agcd_fastgcd_make_subresultant_generators
#define SNAP_agcd_fastgcd_make_jacobian_generators supdc_agcd_fastgcd_make_jacobian_generators
#define SNAP_agcd_fastgcd_lcm supdc_agcd_fastgcd_lcm
#define SNAP_agcd_fastgcd_make_trans_matrices supdc_agcd_fastgcd_make_trans_matrices
#define SNAP_agcd_fastgcd_nullvector supdc_agcd_fastgcd_nullvector
#define SNAP_agcd_fastgcd_linesearch supdc_agcd_fastgcd_linesearch

#define SNAP_alg_qr_dgv2010refine_make_sylvester_generators supdc_alg_qr_dgv2010refine_make_sylvester_generators
#define SNAP_alg_qr_dgv2010refine supdc_alg_qr_dgv2010refine
#define SNAP_alg_qr_dgv2010refine_embed supdc_alg_qr_dgv2010refine_embed
#define SNAP_alg_qr_dgv2010refine_sylvester supdc_alg_qr_dgv2010refine_sylvester
#define SNAP_alg_qr_dgv2010refine_apply_S supdc_alg_qr_dgv2010refine_apply_S
#define SNAP_alg_qr_dgv2010refine_givens_R supdc_alg_qr_dgv2010refine_givens_R
#define SNAP_alg_qr_dgv2010refine_givens_C supdc_alg_qr_dgv2010refine_givens_C
#define SNAP_alg_qr_dgv2010refine_pulldownthrough supdc_alg_qr_dgv2010refine_pulldownthrough
#define SNAP_alg_qr_dgv2010refine_pulldownthrough_ws supdc_alg_qr_dgv2010refine_pulldownthrough_ws
#define SNAP_alg_qr_dgv2010refine_pulldownthroughright supdc_alg_qr_dgv2010refine_pulldownthroughright
#define SNAP_alg_qr_dgv2010refine_pullupthrough supdc_alg_qr_dgv2010refine_pullupthrough
#define SNAP_alg_qr_dgv2010refine_pulldownthrough_left supdc_alg_qr_dgv2010refine_pulldownthrough_left
#define SNAP_alg_qr_dgv2010refine_pulldownthroughleft supdc_alg_qr_dgv2010refine_pulldownthroughleft
#define SNAP_alg_qr_dgv2010refine_apply_scalar supdc_alg_qr_dgv2010refine_apply_scalar
#define SNAP_alg_qr_dgv2010refine_chasing supdc_alg_qr_dgv2010refine_chasing
#define SNAP_alg_qr_dgv2010refine_chasing_embed supdc_alg_qr_dgv2010refine_chasing_embed
#define SNAP_alg_qr_dgv2010refine_chasing_embed_nf supdc_alg_qr_dgv2010refine_chasing_embed_nf
#define SNAP_alg_qr_dgv2010refine_givens_LS supdc_alg_qr_dgv2010refine_givens_LS
#define SNAP_alg_qr_dgv2010refine_givens_LS4RF supdc_alg_qr_dgv2010refine_givens_LS4RF

#define SNAP_agcd_gpgcd supdc_agcd_gpgcd
#define SNAP_agcd_gpgcd_construct_tildevectors supdc_agcd_gpgcd_construct_tildevectors
#define SNAP_agcd_gpgcd_initial_cofactors supdc_agcd_gpgcd_initial_cofactors
#define SNAP_agcd_gpgcd_subresultant_mapping_matrix_dsc supdc_agcd_gpgcd_subresultant_mapping_matrix_dsc
#define SNAP_agcd_gpgcd_modified_newton supdc_agcd_gpgcd_modified_newton
#define SNAP_agcd_gpgcd_Jacobian supdc_agcd_gpgcd_Jacobian
#define SNAP_agcd_gpgcd_nabla supdc_agcd_gpgcd_nabla
#define SNAP_agcd_gpgcd_const supdc_agcd_gpgcd_const
#define SNAP_agcd_gpgcd_direction supdc_agcd_gpgcd_direction
#define SNAP_agcd_gpgcd_update supdc_agcd_gpgcd_update
#define SNAP_agcd_gpgcd_lsdiv supdc_agcd_gpgcd_lsdiv
#define SNAP_agcd_gpgcd_pseudo_inverse_by_svd supdc_agcd_gpgcd_pseudo_inverse_by_svd
#define SNAP_agcd_gpgcd_pseudo_inverse_by_tri supdc_agcd_gpgcd_pseudo_inverse_by_tri
#define SNAP_agcd_gpgcd2 supdc_agcd_gpgcd2
#define SNAP_agcd_gpgcd_initial_vector supdc_agcd_gpgcd_initial_vector
#define SNAP_agcd_gpgcd_modified_newton2 supdc_agcd_gpgcd_modified_newton2
#define SNAP_agcd_gpgcd_ex supdc_agcd_gpgcd_ex
#define SNAP_agcd_gpgcd_modified_newton_ex supdc_agcd_gpgcd_modified_newton_ex

#define SNAP_agcd_stlngcd supdc_agcd_stlngcd
#define SNAP_agcd_stlngcd2 supdc_agcd_stlngcd2
#define SNAP_agcd_stlngcd2_convolution_like_matrix supdc_agcd_stlngcd2_convolution_like_matrix
#define SNAP_agcd_stlngcd2_init_Ak supdc_agcd_stlngcd2_init_Ak
#define SNAP_agcd_stlngcd2_update_Ak supdc_agcd_stlngcd2_update_Ak
#define SNAP_agcd_stlngcd2_convolution_like_matrix_YPk supdc_agcd_stlngcd2_convolution_like_matrix_YPk
#define SNAP_agcd_stlngcd_ex supdc_agcd_stlngcd_ex
#define SNAP_agcd_stlngcd2_ex supdc_agcd_stlngcd2_ex
#define SNAP_agcd_stlngcd2x_ex supdc_agcd_stlngcd2x_ex

#define SNAPBASE_t dcomplex
#define SNAPBASE_mpfr_rnd_t mpfr_rnd_t
#define SNAPBASE_mpc_rnd_t mpc_rnd_t
// #define SNAPBASE_RNDN MPFR_RNDN
#define SNAPBASE_init(a) (a=0.0)
#define SNAPBASE_clear(a) {}
#define SNAPBASE_init_set(a,b) (a=(b))
#define SNAPBASE_init_set_ui(a,b) (a=(dcomplex)(b))
#define SNAPBASE_init_set_si(a,b) (a=(dcomplex)(b))
#define SNAPBASE_init_set_d(a,b) (a=(dcomplex)(b))
#define SNAPBASE_set(a,b) (a=(b))
#define SNAPBASE_set_base(a,b) (a=(b))
#define SNAPBASE_set_basereal(a,b) (a=(dcomplex)(b))
#define SNAPBASE_set_basereal2(a,b,c) (a=(b)+(c)*_Complex_I)
#define SNAPBASE_set_basecomplex(a,b) (a=(b))
#define SNAPBASE_set_ui(a,b) (a=(dcomplex)(b))
#define SNAPBASE_set_si(a,b) (a=(dcomplex)(b))
#define SNAPBASE_set_z(a,b) (a=(dcomplex) mpz_get_d(b))
#define SNAPBASE_set_fr(a,b) (a=(dcomplex) mpfr_get_d(b,SNAPLIB_MPFR_RND))
#define SNAPBASE_set_fc(a,b) (a=(dcomplex) (mpfr_get_d(mpc_realref(b),MPC_RND_RE(SNAPLIB_MPC_RND))+(mpfr_get_d(mpc_imagref(b),MPC_RND_IM(SNAPLIB_MPC_RND)))*_Complex_I))
#define SNAPBASE_set_d(a,b) (a=(dcomplex)(b))
#define SNAPBASE_set_dc(a,b) (a=(b))
#define SNAPBASE_set_str(a,b,c) (a=(dcomplex)strtod(b,NULL))
// #define SNAPBASE_get_str(a,b,c) mpfr_get_str(a, b, c)
// We assume that round mode is ROUND TO THE NEAREST
// #define SNAPBASE_get_ui_rnd(a) (lround(a))
// #define SNAPBASE_sgn(a) (a)
#define SNAPBASE_zeroq(a) ((a) == (dcomplex)0.0)
#define SNAPBASE_nan_p(a) (isnan(a))
#define SNAPBASE_abs(a,b) (a=cabs(b))
#define SNAPBASE_normsquare(a,b) (a=creal(b)*creal(b)+cimag(b)*cimag(b))
#define SNAPBASE_cmp(a,b) ((a)-(b))
#define SNAPBASE_cmp_realpart(a,b) (creal(a)-creal(b))
#define SNAPBASE_cmp_realpart_basereal(a,b) (creal(a)-(b))
#define SNAPBASE_cmpabs(a,b) (cabs(a)-cabs(b))
#define SNAPBASE_cmpabs_basereal(a,b) (cabs(a)-fabs(b))
#define SNAPBASE_cmp_ui(a,b) ((dcomplex)(a)-(b))
#define SNAPBASE_real(a) creal(a)
#define SNAPBASE_imag(a) cimag(a)
#define SNAPBASE_conj(a,b) (a=conj(b))
#define SNAPBASE_conj_base(a,b) (a=conj(b))
#define SNAPBASE_neg(a,b) (a=-(b))
#define SNAPBASE_neg_base(a,b) (a=-(b))
#define SNAPBASE_neg_basereal(a,b) (a=-(b))
#define SNAPBASE_rec(a,b) (a=(1/b))
#define SNAPBASE_swap(a,b) do{dcomplex SNAP_tmp;SNAP_tmp=(a);a=(b);b=SNAP_tmp;}while(0)
#define SNAPBASE_add(a,b,c) (a=(b)+(c))
#define SNAPBASE_add_base(a,b,c) (a=(b)+(c))
#define SNAPBASE_add_basereal_basereal(a,b,c,d) (a=(b)+(c)+(d)*_Complex_I)
#define SNAPBASE_add_d(a,b,c) (a=(b)+(dcomplex)(c))
#define SNAPBASE_sub(a,b,c) (a=(b)-(c))
#define SNAPBASE_sub_base(a,b,c) (a=(b)-(c))
#define SNAPBASE_sub_d(a,b,c) (a=(b)-(dcomplex)(c))
#define SNAPBASE_sub_dc(a,b,c) (a=(b)-(c))
#define SNAPBASE_addmul(a,b,c) (a+=(b)*(c))
#define SNAPBASE_submul(a,b,c) (a-=(b)*(c))
#define SNAPBASE_submul_basecomplex_basecomplex(a,b,c) (a-=(b)*(c))
#define SNAPBASE_mul(a,b,c) (a=(b)*(c))
#define SNAPBASE_mul_base(a,b,c) (a=(b)*(c))
#define SNAPBASE_mul_basereal(a,b,c) (a=(b)*((dcomplex)c))
#define SNAPBASE_mul_d(a,b,c) (a=(b)*((dcomplex)(c)))
#define SNAPBASE_mul_dc(a,b,c) (a=(b)*(c))
#define SNAPBASE_mul_ui(a,b,c) (a=(b)*((dcomplex)(c)))
#define SNAPBASE_mul_si(a,b,c) (a=(b)*((dcomplex)(c)))
#define SNAPBASE_mul_fr(a,b,c) (a=(b)*((dcomplex)mpfr_get_d(c,SNAPLIB_MPFR_RND)))
#define SNAPBASE_div(a,b,c) (a=(b)/(c))
#define SNAPBASE_div_basereal(a,b,c) (a=(b)/((dcomplex)(c)))
#define SNAPBASE_div_fr(a,b,c) (a=(b)/((dcomplex)mpfr_get_d(c,SNAPLIB_MPFR_RND)))
#define SNAPBASE_div_fc(a,b,c) (a=(b)/((dcomplex)mpc_get_dc(c,SNAPLIB_MPC_RND)))
#define SNAPBASE_div_d(a,b,c) (a=(b)/((dcomplex)(c)))
#define SNAPBASE_div_dc(a,b,c) (a=(b)/(c))
#define SNAPBASE_div_ui(a,b,c) (a=(b)/((dcomplex)(c)))
#define SNAPBASE_div_si(a,b,c) (a=(b)/((dcomplex)(c)))
#define SNAPBASE_sqrt(a,b) (a=csqrt(b))
#define SNAPBASE_sqrt_ui(a,b) (a=(dcomplex)sqrt((double)(b)))
#define SNAPBASE_urandom(a,b) (a=((double) rand()/((double)RAND_MAX+1))+((double) rand()/((double)RAND_MAX+1))*_Complex_I)

#define SNAPBASEREAL_t double
#define SNAPBASEREAL_mpfr_rnd_t mpfr_rnd_t
// #define SNAPBASEREAL_RNDN MPFR_RNDN
#define SNAPBASEREAL_init(a) (a=0.0)
#define SNAPBASEREAL_clear(a) {}
#define SNAPBASEREAL_init_set(a,b) (a=(b))
#define SNAPBASEREAL_init_set_ui(a,b) (a=(double)(b))
#define SNAPBASEREAL_init_set_d(a,b) (a=(double)(b))
#define SNAPBASEREAL_set(a,b) (a=(b))
#define SNAPBASEREAL_set_basecomplex(a,b) (a=creal(b))
#define SNAPBASEREAL_set_ui(a,b) (a=(double)(b))
#define SNAPBASEREAL_set_si(a,b) (a=(double)(b))
#define SNAPBASEREAL_set_z(a,b) (a=(double) mpz_get_d(b))
#define SNAPBASEREAL_set_fr(a,b) (a=(double) mpfr_get_d(b,SNAPLIB_MPFR_RND))
#define SNAPBASEREAL_set_d(a,b) (a=(b))
#define SNAPBASEREAL_set_str(a,b,c) (a=(double)strtod(b,NULL))
// #define SNAPBASEREAL_get_str(a,b,c) mpfr_get_str(a, b, c)
// We assume that round mode is ROUND TO THE NEAREST
#define SNAPBASEREAL_get_ui_rnd(a) (lround(a))
#define SNAPBASEREAL_sgn(a) (a)
#define SNAPBASEREAL_zeroq(a) ((a) == 0.0)
#define SNAPBASEREAL_nan_p(a) (isnan(a))
#define SNAPBASEREAL_abs(a,b) (a=fabs(b))
#define SNAPBASEREAL_cmp(a,b) ((a)-(b))
#define SNAPBASEREAL_cmp_ui(a,b) ((double)(a)-(b))
#define SNAPBASEREAL_cmpabs(a,b) (fabs(a)-fabs(b))
#define SNAPBASEREAL_neg(a,b) (a=-(b))
#define SNAPBASEREAL_rec(a,b) (a=(1/b))
#define SNAPBASEREAL_swap(a,b) do{double SNAP_tmp;SNAP_tmp=(a);a=(b);b=SNAP_tmp;}while(0)
#define SNAPBASEREAL_add(a,b,c) (a=(b)+(c))
#define SNAPBASEREAL_add_d(a,b,c) (a=(b)+(c))
#define SNAPBASEREAL_add_ui(a,b,c) (a=(b)+((double)(c)))
#define SNAPBASEREAL_sub(a,b,c) (a=(b)-(c))
#define SNAPBASEREAL_sub_d(a,b,c) (a=(b)-(c))
#define SNAPBASEREAL_sub_ui(a,b,c) (a=(b)-((double)(c)))
#define SNAPBASEREAL_addmul(a,b,c) (a+=(b)*(c))
#define SNAPBASEREAL_addmul_ui_basecomplex(a,b,c) (a+=((double)b)*(creal(c)))
#define SNAPBASEREAL_mul(a,b,c) (a=(b)*(c))
#define SNAPBASEREAL_mul_d(a,b,c) (a=(b)*(c))
#define SNAPBASEREAL_mul_ui(a,b,c) (a=(b)*((double)(c)))
#define SNAPBASEREAL_mul_basereal(a,b,c) (a=(b)*((double)c))
#define SNAPBASEREAL_mul_ui_basecomplex(a,b,c) (a=((double)b)*(creal(c)))
#define SNAPBASEREAL_mul_si(a,b,c) (a=(b)*((double)(c)))
#define SNAPBASEREAL_mul_fr(a,b,c) (a=(b)*((double)mpfr_get_d(c,SNAPLIB_MPFR_RND)))
#define SNAPBASEREAL_div(a,b,c) (a=(b)/(c))
#define SNAPBASEREAL_div_fr(a,b,c) (a=(b)/((double)mpfr_get_d(c,SNAPLIB_MPFR_RND)))
#define SNAPBASEREAL_div_fc(a,b,c) (a=(b)/((double)mpc_get_dc(c,SNAPLIB_MPC_RND)))
#define SNAPBASEREAL_div_d(a,b,c) (a=(b)/(c))
#define SNAPBASEREAL_div_dc(a,b,c) (a=(b)/((double)(c)))
#define SNAPBASEREAL_div_ui(a,b,c) (a=(b)/((double)(c)))
#define SNAPBASEREAL_div_si(a,b,c) (a=(b)/((double)(c)))
#define SNAPBASEREAL_sqrt(a,b) (a=sqrt(b))
#define SNAPBASEREAL_sqrt_ui(a,b) (a=(double)sqrt((double)(b)))
#define SNAPBASEREAL_urandom(a,b) (a=((double) rand()/((double)RAND_MAX+1)))

#define SNAPBASECOMPLEX_t SNAPBASE_t
#define SNAPBASECOMPLEX_mpfr_rnd_t SNAPBASE_mpfr_rnd_t
#define SNAPBASECOMPLEX_init SNAPBASE_init
#define SNAPBASECOMPLEX_clear SNAPBASE_clear
#define SNAPBASECOMPLEX_init_set SNAPBASE_init_set
#define SNAPBASECOMPLEX_init_set_ui SNAPBASE_init_set_ui
#define SNAPBASECOMPLEX_init_set_si SNAPBASE_init_set_si
#define SNAPBASECOMPLEX_init_set_d SNAPBASE_init_set_d
#define SNAPBASECOMPLEX_set SNAPBASE_set
#define SNAPBASECOMPLEX_set_base SNAPBASE_set_base
#define SNAPBASECOMPLEX_set_basereal SNAPBASE_set_basereal
#define SNAPBASECOMPLEX_set_ui SNAPBASE_set_ui
#define SNAPBASECOMPLEX_set_si SNAPBASE_set_si
#define SNAPBASECOMPLEX_set_z SNAPBASE_set_z
#define SNAPBASECOMPLEX_set_fr SNAPBASE_set_fr
#define SNAPBASECOMPLEX_set_d SNAPBASE_set_d
#define SNAPBASECOMPLEX_set_dc SNAPBASE_set_dc
#define SNAPBASECOMPLEX_set_str SNAPBASE_set_str
#define SNAPBASECOMPLEX_zeroq SNAPBASE_zeroq
#define SNAPBASECOMPLEX_nan_p SNAPBASE_nan_p
#define SNAPBASECOMPLEX_abs SNAPBASE_abs
#define SNAPBASECOMPLEX_normsquare SNAPBASE_normsquare
#define SNAPBASECOMPLEX_cmp SNAPBASE_cmp
#define SNAPBASECOMPLEX_cmp_realpart SNAPBASE_cmp_realpart
#define SNAPBASECOMPLEX_cmp_realpart_basereal SNAPBASE_cmp_realpart_basereal
#define SNAPBASECOMPLEX_cmpabs SNAPBASE_cmpabs
#define SNAPBASECOMPLEX_cmpabs_basereal SNAPBASE_cmpabs_basereal
#define SNAPBASECOMPLEX_cmp_ui SNAPBASE_cmp_ui
#define SNAPBASECOMPLEX_real SNAPBASE_real
#define SNAPBASECOMPLEX_imag SNAPBASE_imag
#define SNAPBASECOMPLEX_conj SNAPBASE_conj
#define SNAPBASECOMPLEX_conj_base SNAPBASE_conj_base
#define SNAPBASECOMPLEX_neg SNAPBASE_neg
#define SNAPBASECOMPLEX_neg_base SNAPBASE_neg_base
#define SNAPBASECOMPLEX_neg_basereal SNAPBASE_neg_basereal
#define SNAPBASECOMPLEX_rec SNAPBASE_rec
#define SNAPBASECOMPLEX_swap SNAPBASE_swap
#define SNAPBASECOMPLEX_add SNAPBASE_add
#define SNAPBASECOMPLEX_add_base SNAPBASE_add_base
#define SNAPBASECOMPLEX_add_d SNAPBASE_add_d
#define SNAPBASECOMPLEX_sub SNAPBASE_sub
#define SNAPBASECOMPLEX_sub_base SNAPBASE_sub_base
#define SNAPBASECOMPLEX_sub_d SNAPBASE_sub_d
#define SNAPBASECOMPLEX_addmul SNAPBASE_addmul
#define SNAPBASECOMPLEX_submul SNAPBASE_submul
#define SNAPBASECOMPLEX_mul SNAPBASE_mul
#define SNAPBASECOMPLEX_mul_base SNAPBASE_mul_base
#define SNAPBASECOMPLEX_mul_basereal SNAPBASE_mul_basereal
#define SNAPBASECOMPLEX_mul_d SNAPBASE_mul_d
#define SNAPBASECOMPLEX_mul_dc SNAPBASE_mul_dc
#define SNAPBASECOMPLEX_mul_ui SNAPBASE_mul_ui
#define SNAPBASECOMPLEX_mul_si SNAPBASE_mul_si
#define SNAPBASECOMPLEX_mul_fr SNAPBASE_mul_fr
#define SNAPBASECOMPLEX_div SNAPBASE_div
#define SNAPBASECOMPLEX_div_basereal SNAPBASE_div_basereal
#define SNAPBASECOMPLEX_div_fr SNAPBASE_div_fr
#define SNAPBASECOMPLEX_div_fc SNAPBASE_div_fc
#define SNAPBASECOMPLEX_div_d SNAPBASE_div_d
#define SNAPBASECOMPLEX_div_dc SNAPBASE_div_dc
#define SNAPBASECOMPLEX_div_ui SNAPBASE_div_ui
#define SNAPBASECOMPLEX_div_si SNAPBASE_div_si
#define SNAPBASECOMPLEX_sqrt SNAPBASE_sqrt
#define SNAPBASECOMPLEX_sqrt_ui SNAPBASE_sqrt_ui
#define SNAPBASECOMPLEX_urandom SNAPBASE_urandom

#define SNAPMTX_t sdmdc_t
#define SNAPMTX_init sdmdc_init
#define SNAPMTX_init2 sdmdc_init2
#define SNAPMTX_reinit2 sdmdc_reinit2
#define SNAPMTX_reinit3 sdmdc_reinit3
#define SNAPMTX_realloc sdmdc_realloc
#define SNAPMTX_clear sdmdc_clear
#define SNAPMTX_swap sdmdc_swap
#define SNAPMTX_subresultant_mapping_matrix_asc(a,b,c,d) sdmdc_subresultant_mapping_matrix_asc(a, b, c, d)
#define SNAPMTX_subresultant_mapping_matrix_dsc(a,b,c,d) sdmdc_subresultant_mapping_matrix_dsc(a, b, c, d)
#define SNAPMTX_subresultant_mapping_matrix_transpose(a,b,c,d) sdmdc_subresultant_mapping_matrix_transpose(a, b, c, d)
#define SNAPMTX_subresultant_mapping_matrix_transpose_column_major(a,b,c,d) sdmdc_subresultant_mapping_matrix_transpose_column_major(a, b, c, d)
#define SNAPMTX_convolution_matrix(a,b,c) sdmdc_convolution_matrix(a, b, c)
#define SNAPMTX_convolution_matrix_conj(a,b,c) sdmdc_convolution_matrix_conj(a, b, c)
#define SNAPMTX_convolution_matrix_column_major(a,b,c) sdmdc_convolution_matrix_column_major(a, b, c)
#define SNAPMTX_convolution_matrix_zerofill(a,b,c) sdmdc_convolution_matrix_zerofill(a, b, c)
#define SNAPMTX_convolution_matrix_zerofill_conj(a,b,c) sdmdc_convolution_matrix_zerofill_conj(a, b, c)
#define SNAPMTX_sylvester_matrix_transpose(a,b,c) sdmdc_sylvester_matrix_transpose(a, b, c)
#define SNAPMTX_rows sdmdc_rows
#define SNAPMTX_rsize sdmdc_rsize
#define SNAPMTX_cols sdmdc_cols
#define SNAPMTX_csize sdmdc_csize
#define SNAPMTX_elem sdmdc_elem
#define SNAPMTX_elem_column_major sdmdc_elem_column_major
#define SNAPMTX_elems sdmdc_elems
#define SNAPMTX_elemp sdmdc_elemp
#define SNAPMTX_elemp_column_major sdmdc_elemp_column_major

#define SNAPMTXREAL_t sdmd_t
#define SNAPMTXREAL_init sdmd_init
#define SNAPMTXREAL_init2 sdmd_init2
#define SNAPMTXREAL_reinit2 sdmd_reinit2
#define SNAPMTXREAL_reinit3 sdmd_reinit3
#define SNAPMTXREAL_realloc sdmd_realloc
#define SNAPMTXREAL_clear sdmd_clear
#define SNAPMTXREAL_swap sdmd_swap
#define SNAPMTXREAL_rows sdmd_rows
#define SNAPMTXREAL_rsize sdmd_rsize
#define SNAPMTXREAL_cols sdmd_cols
#define SNAPMTXREAL_csize sdmd_csize
#define SNAPMTXREAL_elem sdmd_elem
#define SNAPMTXREAL_elem_column_major sdmd_elem_column_major
#define SNAPMTXREAL_elems sdmd_elems
#define SNAPMTXREAL_elemp sdmd_elemp
#define SNAPMTXREAL_elemp_column_major sdmd_elemp_column_major

#define SNAPMTXCOMPLEX_t sdmdc_t
#define SNAPMTXCOMPLEX_init sdmdc_init
#define SNAPMTXCOMPLEX_init2 sdmdc_init2
#define SNAPMTXCOMPLEX_reinit2 sdmdc_reinit2
#define SNAPMTXCOMPLEX_reinit3 sdmdc_reinit3
#define SNAPMTXCOMPLEX_realloc sdmdc_realloc
#define SNAPMTXCOMPLEX_clear sdmdc_clear
#define SNAPMTXCOMPLEX_swap sdmdc_swap
#define SNAPMTXCOMPLEX_rows sdmdc_rows
#define SNAPMTXCOMPLEX_rsize sdmdc_rsize
#define SNAPMTXCOMPLEX_cols sdmdc_cols
#define SNAPMTXCOMPLEX_csize sdmdc_csize
#define SNAPMTXCOMPLEX_elem sdmdc_elem
#define SNAPMTXCOMPLEX_elem_column_major sdmdc_elem_column_major
#define SNAPMTXCOMPLEX_elems sdmdc_elems
#define SNAPMTXCOMPLEX_elemp sdmdc_elemp
#define SNAPMTXCOMPLEX_elemp_column_major sdmdc_elemp_column_major


// compatiblity for BLAS and MBLAS
#define SNAPMTX_BLAS_nrm2(a,b,c,d) (a=cblas_dznrm2(b, c, d))
#define SNAPMTXREAL_BLAS_nrm2(a,b,c,d) (a=cblas_dnrm2(b, c, d))
#define SNAPMTXCOMPLEX_BLAS_nrm2(a,b,c,d) (a=cblas_dznrm2(b, c, d))
// #define SNAPMTX_BLAS_dot(a,b,c,d,e,f) (a=cblas_ddot(b, c, d, e, f))
#define SNAPMTXREAL_BLAS_dot(a,b,c,d,e,f) (a=cblas_ddot(b, c, d, e, f))
#define SNAPMTX_BLAS_dotc(a,b,c,d,e,f) (cblas_zdotc_sub(b,c,d,e,f,&a))
#define SNAPMTXCOMPLEX_BLAS_dotc(a,b,c,d,e,f) (cblas_zdotc_sub(b,c,d,e,f,&a))
#define SNAPMTX_BLAS_dotu(a,b,c,d,e,f) (cblas_zdotu_sub(b,c,d,e,f,&a))
#define SNAPMTXCOMPLEX_BLAS_dotu(a,b,c,d,e,f) (cblas_zdotu_sub(b,c,d,e,f,&a))
#define SNAPMTX_BLAS_swap(a,b,c,d,e) (cblas_zswap(a,b,c,d,e))
#define SNAPMTXCOMPLEX_BLAS_swap(a,b,c,d,e) (cblas_zswap(a,b,c,d,e))
#define SNAPMTXREAL_BLAS_scal(a,b,c,d) (cblas_dscal(a,b,c,d))
#define SNAP_gelsy snap_lapack_zgelsy_givens

