/*
 * Copyright (c) 2012-2015, Kosaku Nagasaka <nagasaka@main.h.kobe-u.ac.jp>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define SNAP_SUPFC_T

#define SNAP_t supfc_t
#define SNAP_init supfc_init
#define SNAP_init2 supfc_init2
#define SNAP_init_set(a,b) supfc_init_set(a, b)
#define SNAP_clear supfc_clear
#define SNAP_coef supfc_coef
#define SNAP_coefp supfc_coefp
#define SNAP_coefs supfc_coefs
#define SNAP_lcoef supfc_lcoef
#define SNAP_lcoefp supfc_lcoefp
#define SNAP_size supfc_size
#define SNAP_degree supfc_degree
#define SNAP_set(a,b) supfc_set(a, b)
#define SNAP_set_base(a,b,c) supfc_set_fc(a, b, c)
#define SNAP_set_basecomplex(a,b,c) supfc_set_fc(a, b, c)
#define SNAP_set_rbase(a,b,c) supfc_set_rfc(a, b, c)
#define SNAP_set_rbasecomplex(a,b,c) supfc_set_rfc(a, b, c)
#define SNAP_set_z(a,b,c) supfc_set_z(a, b, c)
#define SNAP_set_d(a,b,c) supfc_set_d(a, b, c)
#define SNAP_set_rd(a,b,c) supfc_set_rd(a, b, c)
#define SNAP_set_dc(a,b,c) supfc_set_dc(a, b, c)
#define SNAP_set_rdc(a,b,c) supfc_set_rdc(a, b, c)
#define SNAP_set_fr(a,b,c) supfc_set_fr(a, b, c)
#define SNAP_set_rfr(a,b,c) supfc_set_rfr(a, b, c)
#define SNAP_set_fc(a,b,c) supfc_set_fc(a, b, c)
#define SNAP_set_rfc(a,b,c) supfc_set_rfc(a, b, c)
#define SNAP_set_coef(a,b,c) supfc_set_coef(a, b, c)
#define SNAP_set_coef_d(a,b,c) supfc_set_coef_d(a, b, c)
#define SNAP_set_str(a,b) supfc_set_str(a, b)
#define SNAP_set_str_real(a,b,c) supfc_set_str_real(a, b, c)
#define SNAP_set_str_imag(a,b,c) supfc_set_str_imag(a, b, c)
#define SNAP_set_str_ppnumber(a,b,c) supfc_set_str_ppnumber(a, b, c)
#define SNAP_set_str_number(a,b,c) supfc_set_str_number(a, b, c)
#define SNAP_set_str_num(a,b,c) supfc_set_str_num(a, b, c)
#define SNAP_set_str_term(a,b) supfc_set_str_term(a, b)
#define SNAP_set_str_ppmonomial(a,b,c) supfc_set_str_ppmonomial(a, b, c)
#define SNAP_set_str_monomial(a,b) supfc_set_str_monomial(a, b)
#define SNAP_set_str_poly(a,b) supfc_set_str_poly(a, b)
#define SNAP_set_str_polyall(a,b) supfc_set_str_polyall(a, b)
#define SNAP_swap supfc_swap
#define SNAP_2norm(a,b) supfc_2norm(a, b)
#define SNAP_self_neg(a) supfc_self_neg(a)
#define SNAP_self_reversal supfc_self_reversal
#define SNAP_add(a,b,c) supfc_add(a, b, c)
#define SNAP_sub(a,b,c) supfc_sub(a, b, c)
#define SNAP_mul(a,b,c) supfc_mul(a, b, c)
#define SNAP_mul_traditional_nc(a,b,c) supfc_mul_traditional_nc(a, b, c)
#define SNAP_mul_traditional(a,b,c) supfc_mul_traditional(a, b, c)
#define SNAP_mul_karatsuba_main(a,b,c,d,e,f,g,h,i,j,k,l,m,n) supfc_mul_karatsuba_main(a, b, c, d, e, f, g, h, i, j, k, l, m, n)
#define SNAP_mul_karatsuba_nc(a,b,c,d) supfc_mul_karatsuba_nc(a, b, c, d)
#define SNAP_mul_karatsuba(a,b,c) supfc_mul_karatsuba(a, b, c)
#define SNAP_mul_karatsuba_block_nc(a,b,c) supfc_mul_karatsuba_block_nc(a, b, c)
#define SNAP_mul_karatsuba_block(a,b,c) supfc_mul_karatsuba_block(a, b, c)
#define SNAP_mul_base(a,b,c) supfc_mul_fc(a, b, c)
#define SNAP_mul_basereal(a,b,c) supfc_mul_fr(a, b, c)
#define SNAP_mul_fr(a,b,c) supfc_mul_fr(a, b, c)
#define SNAP_mul_si(a,b,c) supfc_mul_si(a, b, c)
#define SNAP_mul_d(a,b,c) supfc_mul_d(a, b, c)
#define SNAP_mul_dc(a,b,c) supfc_mul_dc(a, b, c)
#define SNAP_div_qr_nc(a,b,c) supfc_div_qr_nc(a, b, c)
#define SNAP_div_qr(a,b,c,d) supfc_div_qr(a, b, c, d)
#define SNAP_lsdiv_q(a,b,c) supfc_lsdiv_q(a, b, c)
#define SNAP_fftdiv_q(a,b,c) supfc_fftdiv_q(a, b, c)
#define SNAP_div_base(a,b,c) supfc_div_fc(a, b, c)
#define SNAP_div_basereal(a,b,c) supfc_div_fr(a, b, c)
#define SNAP_div_fr(a,b,c) supfc_div_fr(a, b, c)
#define SNAP_div_fc(a,b,c) supfc_div_fc(a, b, c)
#define SNAP_div_d(a,b,c) supfc_div_d(a, b, c)
#define SNAP_div_dc(a,b,c) supfc_div_dc(a, b, c)
#define SNAP_randpoly(a,b,c,d,e) supfc_randpoly(a, b, c, d, e)

#define SNAP_agcd_exqrgcd_rootsquaring supfc_agcd_exqrgcd_rootsquaring
#define SNAP_agcd_exqrgcd_fft supfc_agcd_exqrgcd_fft
#define SNAP_agcd_exqrgcd_roughsplit supfc_agcd_exqrgcd_roughsplit
#define SNAP_agcd_exqrgcd_split supfc_agcd_exqrgcd_split
#define SNAP_agcd_exqrgcd_quicksort_uint_by_base_nc supfc_agcd_exqrgcd_quicksort_uint_by_mpc_nc
#define SNAP_agcd_exqrgcd_quicksort_uint_by_base supfc_agcd_exqrgcd_quicksort_uint_by_mpc
#define SNAP_agcd_exqrgcd_Qkthcolumn supfc_agcd_exqrgcd_Qkthcolumn
#define SNAP_agcd_exqrgcd supfc_agcd_exqrgcd
#define SNAP_agcd_exqrgcd_qrstep supfc_agcd_exqrgcd_qrstep

#define SNAP_agcd_qrgcd supfc_agcd_qrgcd
#define SNAP_agcd_qrgcd_qrstep supfc_agcd_qrgcd_qrstep

#define SNAP_agcd_uvgcd supfc_agcd_uvgcd
#define SNAP_agcd_uvgcd_iteration_7_3(a,b,c,d,e) supfc_agcd_uvgcd_iteration_7_3(a, b, c, d, e)
#define SNAP_agcd_uvgcd_solving_10_2(a,b,c,d,e,f) supfc_agcd_uvgcd_solving_10_2(a, b, c, d, e, f)
#define SNAP_agcd_uvgcd_update(a,b,c,d,e,f,g) supfc_agcd_uvgcd_update(a, b, c, d, e, f, g)
#define SNAP_agcd_uvgcd_iteration_9_2(a,b,c,d,e,f) supfc_agcd_uvgcd_iteration_9_2(a, b, c, d, e, f)
#define SNAP_agcd_uvgcd_ex supfc_agcd_uvgcd_ex

#define SNAP_agcd_fastgcd supfc_agcd_fastgcd
#define SNAP_agcd_fastgcd_refine supfc_agcd_fastgcd_refine
#define SNAP_agcd_fastgcd_modified_gko supfc_agcd_fastgcd_modified_gko
#define SNAP_agcd_fastgcd_make_cauchy_generators supfc_agcd_fastgcd_make_cauchy_generators
#define SNAP_agcd_fastgcd_make_sylvester_generators supfc_agcd_fastgcd_make_sylvester_generators
#define SNAP_agcd_fastgcd_make_subresultant_generators supfc_agcd_fastgcd_make_subresultant_generators
#define SNAP_agcd_fastgcd_make_jacobian_generators supfc_agcd_fastgcd_make_jacobian_generators
#define SNAP_agcd_fastgcd_lcm supfc_agcd_fastgcd_lcm
#define SNAP_agcd_fastgcd_make_trans_matrices supfc_agcd_fastgcd_make_trans_matrices
#define SNAP_agcd_fastgcd_nullvector supfc_agcd_fastgcd_nullvector
#define SNAP_agcd_fastgcd_linesearch supfc_agcd_fastgcd_linesearch

#define SNAPBASE_t mpc_t
#define SNAPBASE_prec_t mpfr_prec_t
#define SNAPBASE_get_default_prec mpfr_get_default_prec
#define SNAPBASE_rnd_t mpc_rnd_t
#define SNAPBASE_mpfr_rnd_t mpfr_rnd_t
#define SNAPBASE_mpc_rnd_t mpc_rnd_t
#define SNAPBASE_RNDN MPC_RNDNN
#define SNAPBASE_const_pi(a) (mpfr_const_pi(mpc_realref(a), SNAPLIB_MPFR_RND);mpfr_set_ui(mpc_imagref(a),0,SNAPLIB_MPFR_RND))
#define SNAPBASE_init(a) mpc_init2(a, SNAPBASE_get_default_prec())
#define SNAPBASE_init2(a,b) mpc_init2(a, b)
#define SNAPBASE_clear mpc_clear
#define SNAPBASE_init_set(a,b) mpc_init_set(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_init_set_ui(a,b) mpc_init_set_ui(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_init_set_si(a,b) mpc_init_set_si(a, b, SNAPLIB_MPC_RND)
// #define SNAPBASE_init_set_d(a,b) mpfr_init_set_d(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_set(a,b) mpc_set(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_set_base(a,b) mpc_set(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_set_basereal(a,b) mpc_set_fr(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_set_basereal2(a,b,c) mpc_set_fr_fr(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASE_set_basecomplex(a,b) mpc_set(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_set_ui(a,b) mpc_set_ui(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_set_si(a,b) mpc_set_si(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_set_z(a,b) mpc_set_z(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_set_fr(a,b) mpc_set_fr(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_set_fc(a,b) mpc_set(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_set_d(a,b) mpc_set_d(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_set_dc(a,b) mpc_set_dc(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_set_str(a,b,c) mpc_set_str(a, b, c, SNAPLIB_MPC_RND)
// #define SNAPBASE_get_str(a,b,c) mpfr_get_str(a, b, c, SNAPLIB_MPFR_RND)
// We assume that round mode is ROUND TO THE NEAREST
// #define SNAPBASE_get_d(a,b) mpfr_get_d(a, b)
// #define SNAPBASE_get_ui_rnd(a) mpfr_get_ui(a, MPFR_RNDN)
// #define SNAPBASE_sgn(a) mpfr_sgn(a)
#define SNAPBASE_zeroq(a) (mpfr_sgn(mpc_realref(a)) == 0 && mpfr_sgn(mpc_imagref(a)) == 0)
// #define SNAPBASE_nan_p(a) mpfr_nan_p(a)
#define SNAPBASE_abs(a,b) mpc_abs(a, b, MPC_RND_RE(SNAPLIB_MPC_RND))
#define SNAPBASE_cmp(a,b) mpc_cmp(a, b)
// #define SNAPBASE_cmp_ui(a,b) mpfr_cmp_ui(a, b)
#define SNAPBASE_realref(a) mpc_realref(a)
#define SNAPBASE_imagref(a) mpc_imagref(a)
#define SNAPBASE_conj(a,b) mpc_conj(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_neg(a,b) mpc_neg(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_swap(a,b) mpc_swap(a, b)
#define SNAPBASE_add(a,b,c) mpc_add(a, b, c, SNAPLIB_MPC_RND)
// #define SNAPBASE_add_d(a,b,c,d) mpfr_add_d(a, b, c, d)
#define SNAPBASE_sub(a,b,c) mpc_sub(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASE_sub_d(a,b,c) mpc_sub_d(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASE_sub_dc(a,b,c) mpc_sub_dc(a, b, c, SNAPLIB_MPC_RND)
// #define SNAPBASE_addmul(a,b,c) N/A
#define SNAPBASE_mul(a,b,c) mpc_mul(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASE_mul_ui(a,b,c) mpc_mul_ui(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASE_mul_si(a,b,c) mpc_mul_si(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASE_mul_d(a,b,c) mpc_mul_d(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASE_mul_dc(a,b,c) mpc_mul_dc(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASE_mul_fr(a,b,c) mpc_mul_fr(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASE_div(a,b,c) mpc_div(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASE_div_basereal(a,b,c) mpc_div_fr(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASE_div_fr(a,b,c) mpc_div_fr(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASE_div_fc(a,b,c) mpc_div(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASE_div_d(a,b,c) mpc_div_d(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASE_div_dc(a,b,c) mpc_div_dc(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASE_div_ui(a,b,c) mpc_div_ui(a, b, c, SNAPLIB_MPC_RND)
// #define SNAPBASE_div_si(a,b,c,d) mpfr_div_si(a, b, c, d)
#define SNAPBASE_ui_div(a,b,c) mpc_ui_div(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASE_sqrt(a,b) mpc_sqrt(a, b, SNAPLIB_MPC_RND)
// #define SNAPBASE_sqrt_ui(a,b,c) mpfr_sqrt_ui(a, b, c)
// #define SNAPBASE_exp2(a,b,c) mpfr_exp2(a, b, c)
#define SNAPBASE_exp(a,b) mpc_exp(a, b, SNAPLIB_MPC_RND)
#define SNAPBASE_urandom(a,b) mpc_urandom(a, b)
#define SNAPBASE_pow(a,b,c) mpc_pow(a, b, c, SNAPLIB_MPC_RND)

#define SNAPBASEREAL_t mpfr_t
#define SNAPBASEREAL_prec_t mpfr_prec_t
#define SNAPBASEREAL_get_default_prec mpfr_get_default_prec
#define SNAPBASEREAL_rnd_t mpfr_rnd_t
#define SNAPBASEREAL_mpfr_rnd_t mpfr_rnd_t
#define SNAPBASEREAL_RNDN MPFR_RNDN
#define SNAPBASEREAL_const_pi(a) mpfr_const_pi(a, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_init mpfr_init
#define SNAPBASEREAL_clear mpfr_clear
#define SNAPBASEREAL_init_set(a,b) mpfr_init_set(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_init_set_ui(a,b) mpfr_init_set_ui(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_init_set_d(a,b) mpfr_init_set_d(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_set(a,b) mpfr_set(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_set_ui(a,b) mpfr_set_ui(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_set_z(a,b) mpfr_set_z(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_set_fr(a,b) mpfr_set(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_set_d(a,b) mpfr_set_d(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_set_dc(a,b) mpfr_set_d(a, creal(b), SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_set_str(a,b,c) mpfr_set_str(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_set_basecomplex(a,b) mpfr_set_fr(a, mpc_realref(b), SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_get_d(a) mpfr_get_d(a, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_get_ui_rnd(a) mpfr_get_ui(a, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_sgn(a) mpfr_sgn(a)
#define SNAPBASEREAL_zeroq(a) (mpfr_sgn(a) == 0)
#define SNAPBASEREAL_nan_p(a) mpfr_nan_p(a)
#define SNAPBASEREAL_abs(a,b) mpfr_abs(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_cmp(a,b) mpfr_cmp(a, b)
#define SNAPBASEREAL_cmp_ui(a,b) mpfr_cmp_ui(a, b)
#define SNAPBASEREAL_neg(a,b) mpfr_neg(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_rec(a,b) mpfr_ui_div(a, 1, b, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_swap(a,b) mpfr_swap(a, b)
#define SNAPBASEREAL_add(a,b,c) mpfr_add(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_add_d(a,b,c) mpfr_add_d(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_add_basecomplex(a,b,c) mpfr_add(a, b, mpc_realref(c), SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_sub(a,b,c) mpfr_sub(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_sub_d(a,b,c) mpfr_sub_d(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_mul(a,b,c) mpfr_mul(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_mul_ui(a,b,c) mpfr_mul_ui(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_mul_si(a,b,c) mpfr_mul_si(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_mul_d(a,b,c) mpfr_mul_d(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_mul_dc(a,b,c) mpfr_mul_d(a, b, creal(c), SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_mul_fr(a,b,c) mpfr_mul(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_div(a,b,c) mpfr_div(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_div_fr(a,b,c) mpfr_div(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_div_fc(a,b,c) mpfr_div(a, b, mpc_realref(c), SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_div_d(a,b,c) mpfr_div_d(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_div_dc(a,b,c) mpfr_div_d(a, b, creal(c), SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_div_ui(a,b,c) mpfr_div_ui(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_div_si(a,b,c) mpfr_div_si(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_ui_div(a,b,c) mpfr_ui_div(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_sqrt(a,b) mpfr_sqrt(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_sqrt_ui(a,b) mpfr_sqrt_ui(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_exp2(a,b) mpfr_exp2(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_urandom(a,b) mpfr_urandom(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASEREAL_ui_pow_ui(a,b,c) mpfr_ui_pow_ui(a, b, c, SNAPLIB_MPFR_RND)

#define SNAPBASECOMPLEX_t SNAPBASE_t
#define SNAPBASECOMPLEX_prec_t SNAPBASE_prec_t
#define SNAPBASECOMPLEX_get_default_prec SNAPBASE_get_default_prec
#define SNAPBASECOMPLEX_rnd_t SNAPBASE_rnd_t
#define SNAPBASECOMPLEX_mpfr_rnd_t SNAPBASE_mpfr_rnd_t
#define SNAPBASECOMPLEX_RNDN SNAPBASE_RNDN
#define SNAPBASECOMPLEX_const_pi SNAPBASE_const_pi
#define SNAPBASECOMPLEX_init SNAPBASE_init
#define SNAPBASECOMPLEX_init2 SNAPBASE_init2
#define SNAPBASECOMPLEX_clear SNAPBASE_clear
#define SNAPBASECOMPLEX_init_set SNAPBASE_init_set
#define SNAPBASECOMPLEX_init_set_ui SNAPBASE_init_set_ui
#define SNAPBASECOMPLEX_init_set_si SNAPBASE_init_set_si
#define SNAPBASECOMPLEX_set SNAPBASE_set
#define SNAPBASECOMPLEX_set_base SNAPBASE_set_base
#define SNAPBASECOMPLEX_set_basereal SNAPBASE_set_basereal
#define SNAPBASECOMPLEX_set_basecomplex SNAPBASE_set_basecomplex
#define SNAPBASECOMPLEX_set_ui SNAPBASE_set_ui
#define SNAPBASECOMPLEX_set_si SNAPBASE_set_si
#define SNAPBASECOMPLEX_set_z SNAPBASE_set_z
#define SNAPBASECOMPLEX_set_fr SNAPBASE_set_fr
#define SNAPBASECOMPLEX_set_d SNAPBASE_set_d
#define SNAPBASECOMPLEX_set_dc SNAPBASE_set_dc
#define SNAPBASECOMPLEX_set_str SNAPBASE_set_str
#define SNAPBASECOMPLEX_zeroq SNAPBASE_zeroq
#define SNAPBASECOMPLEX_abs SNAPBASE_abs
#define SNAPBASECOMPLEX_cmp SNAPBASE_cmp
#define SNAPBASECOMPLEX_realref SNAPBASE_realref
#define SNAPBASECOMPLEX_imagref SNAPBASE_imagref
#define SNAPBASECOMPLEX_conj SNAPBASE_conj
#define SNAPBASECOMPLEX_conj_base SNAPBASE_conj
#define SNAPBASECOMPLEX_neg SNAPBASE_neg
#define SNAPBASECOMPLEX_neg_base SNAPBASE_neg
#define SNAPBASECOMPLEX_swap SNAPBASE_swap
#define SNAPBASECOMPLEX_add SNAPBASE_add
#define SNAPBASECOMPLEX_add_base SNAPBASE_add
#define SNAPBASECOMPLEX_sub SNAPBASE_sub
#define SNAPBASECOMPLEX_sub_base SNAPBASE_sub
#define SNAPBASECOMPLEX_mul SNAPBASE_mul
#define SNAPBASECOMPLEX_mul_base SNAPBASE_mul
#define SNAPBASECOMPLEX_mul_basereal SNAPBASE_mul_fr
#define SNAPBASECOMPLEX_mul_ui SNAPBASE_mul_ui
#define SNAPBASECOMPLEX_mul_si SNAPBASE_mul_si
#define SNAPBASECOMPLEX_mul_d SNAPBASE_mul_d
#define SNAPBASECOMPLEX_mul_dc SNAPBASE_mul_dc
#define SNAPBASECOMPLEX_mul_fr SNAPBASE_mul_fr
#define SNAPBASECOMPLEX_div SNAPBASE_div
#define SNAPBASECOMPLEX_div_fr SNAPBASE_div_fr
#define SNAPBASECOMPLEX_div_fc SNAPBASE_div_fc
#define SNAPBASECOMPLEX_div_d SNAPBASE_div_d
#define SNAPBASECOMPLEX_div_dc SNAPBASE_div_dc
#define SNAPBASECOMPLEX_div_ui SNAPBASE_div_ui
#define SNAPBASECOMPLEX_ui_div SNAPBASE_ui_div
#define SNAPBASECOMPLEX_div_basereal SNAPBASE_div_basereal
#define SNAPBASECOMPLEX_sqrt SNAPBASE_sqrt
#define SNAPBASECOMPLEX_exp SNAPBASE_exp
#define SNAPBASECOMPLEX_urandom SNAPBASE_urandom
#define SNAPBASECOMPLEX_pow SNAPBASE_pow

#define SNAPMTX_t sdmfc_t
#define SNAPMTX_init sdmfc_init
#define SNAPMTX_init2 sdmfc_init2
#define SNAPMTX_reinit2 sdmfc_reinit2
#define SNAPMTX_reinit3 sdmfc_reinit3
#define SNAPMTX_realloc sdmfc_realloc
#define SNAPMTX_clear sdmfc_clear
#define SNAPMTX_swap sdmfc_swap
#define SNAPMTX_subresultant_mapping_matrix_asc(a,b,c,d) sdmfc_subresultant_mapping_matrix_asc(a, b, c, d)
#define SNAPMTX_subresultant_mapping_matrix_dsc(a,b,c,d) sdmfc_subresultant_mapping_matrix_dsc(a, b, c, d)
#define SNAPMTX_subresultant_mapping_matrix_transpose(a,b,c,d) sdmfc_subresultant_mapping_matrix_transpose(a, b, c, d)
#define SNAPMTX_subresultant_mapping_matrix_transpose_column_major(a,b,c,d) sdmfc_subresultant_mapping_matrix_transpose_column_major(a, b, c, d)
#define SNAPMTX_convolution_matrix(a,b,c) sdmfc_convolution_matrix(a, b, c)
#define SNAPMTX_convolution_matrix_conj(a,b,c) sdmfc_convolution_matrix_conj(a, b, c)
#define SNAPMTX_convolution_matrix_column_major(a,b,c) sdmfc_convolution_matrix_column_major(a, b, c)
#define SNAPMTX_convolution_matrix_zerofill(a,b,c) sdmfc_convolution_matrix_zerofill(a, b, c)
#define SNAPMTX_convolution_matrix_zerofill_conj(a,b,c) sdmfc_convolution_matrix_zerofill_conj(a, b, c)
#define SNAPMTX_sylvester_matrix_transpose(a,b,c) sdmfc_sylvester_matrix_transpose(a, b, c)
#define SNAPMTX_rows sdmfc_rows
#define SNAPMTX_rsize sdmfc_rsize
#define SNAPMTX_cols sdmfc_cols
#define SNAPMTX_csize sdmfc_csize
#define SNAPMTX_elem sdmfc_elem
#define SNAPMTX_elem_column_major sdmfc_elem_column_major
#define SNAPMTX_elems sdmfc_elems
#define SNAPMTX_elemp sdmfc_elemp
#define SNAPMTX_elemp_column_major sdmfc_elemp_column_major

#define SNAPMTXCOMPLEX_t SNAPMTX_t
#define SNAPMTXCOMPLEX_init SNAPMTX_init
#define SNAPMTXCOMPLEX_init2 SNAPMTX_init2
#define SNAPMTXCOMPLEX_reinit2 SNAPMTX_reinit2
#define SNAPMTXCOMPLEX_reinit3 SNAPMTX_reinit3
#define SNAPMTXCOMPLEX_realloc SNAPMTX_realloc
#define SNAPMTXCOMPLEX_clear SNAPMTX_clear
#define SNAPMTXCOMPLEX_swap SNAPMTX_swap
#define SNAPMTXCOMPLEX_subresultant_mapping_matrix_asc SNAPMTX_subresultant_mapping_matrix_asc
#define SNAPMTXCOMPLEX_subresultant_mapping_matrix_transpose SNAPMTX_subresultant_mapping_matrix_transpose
#define SNAPMTXCOMPLEX_subresultant_mapping_matrix_transpose_column_major SNAPMTX_subresultant_mapping_matrix_transpose_column_major
#define SNAPMTXCOMPLEX_convolution_matrix SNAPMTX_convolution_matrix
#define SNAPMTXCOMPLEX_convolution_matrix_conj SNAPMTX_convolution_matrix_conj
#define SNAPMTXCOMPLEX_convolution_matrix_column_major SNAPMTX_convolution_matrix_column_major
#define SNAPMTXCOMPLEX_convolution_matrix_zerofill SNAPMTX_convolution_matrix_zerofill
#define SNAPMTXCOMPLEX_convolution_matrix_zerofill_conj SNAPMTX_convolution_matrix_zerofill_conj
#define SNAPMTXCOMPLEX_sylvester_matrix_transpose SNAPMTX_sylvester_matrix_transpose
#define SNAPMTXCOMPLEX_rows SNAPMTX_rows
#define SNAPMTXCOMPLEX_rsize SNAPMTX_rsize
#define SNAPMTXCOMPLEX_cols SNAPMTX_cols
#define SNAPMTXCOMPLEX_csize SNAPMTX_csize
#define SNAPMTXCOMPLEX_elem SNAPMTX_elem
#define SNAPMTXCOMPLEX_elem_column_major SNAPMTX_elem_column_major
#define SNAPMTXCOMPLEX_elems SNAPMTX_elems
#define SNAPMTXCOMPLEX_elemp SNAPMTX_elemp
#define SNAPMTXCOMPLEX_elemp_column_major SNAPMTX_elemp_column_major

// compatiblity for BLAS and MBLAS
#define SNAPMTX_BLAS_nrm2(a,b,c,d) snap_mblas_fcnrm2(a, b, c, d)
#define SNAPMTXCOMPLEX_BLAS_nrm2(a,b,c,d) snap_mblas_fcnrm2(a, b, c, d)
// #define SNAPMTX_BLAS_dot(a,b,c,d,e,f,g) snap_mblas_frdot(a, b, c, d, e, f, g)
#define SNAPMTX_BLAS_dotc(a,b,c,d,e,f) snap_mblas_fcdotc(a, b, c, d, e, f)
#define SNAPMTXCOMPLEX_BLAS_dotc(a,b,c,d,e,f) snap_mblas_fcdotc(a, b, c, d, e, f)
#define SNAPMTXCOMPLEX_BLAS_dotu(a,b,c,d,e,f) (snap_mblas_fcdotu(a,b,c,d,e,f))
#define SNAPMTXCOMPLEX_BLAS_swap(a,b,c,d,e) (snap_mblas_fcswap(a,b,c,d,e))


