/*
 * Copyright (c) 2012-2015, Kosaku Nagasaka <nagasaka@main.h.kobe-u.ac.jp>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define SNAP_SUPFR_T

#define SNAP_t supfr_t
#define SNAP_init supfr_init
#define SNAP_init2 supfr_init2
#define SNAP_init_set(a,b) supfr_init_set(a, b)
#define SNAP_clear supfr_clear
#define SNAP_coef supfr_coef
#define SNAP_coefp supfr_coefp
#define SNAP_coefs supfr_coefs
#define SNAP_lcoef supfr_lcoef
#define SNAP_lcoefp supfr_lcoefp
#define SNAP_size supfr_size
#define SNAP_degree supfr_degree
#define SNAP_set(a,b) supfr_set(a, b)
#define SNAP_set_base(a,b,c) supfr_set_fr(a, b, c)
#define SNAP_set_basecomplex(a,b,c) supfr_set_fc(a, b, c)
#define SNAP_set_rbase(a,b,c) supfr_set_rfr(a, b, c)
#define SNAP_set_rbasecomplex(a,b,c) supfr_set_rfc(a, b, c)
#define SNAP_set_z(a,b,c) supfr_set_z(a, b, c)
#define SNAP_set_d(a,b,c) supfr_set_d(a, b, c)
#define SNAP_set_rd(a,b,c) supfr_set_rd(a, b, c)
#define SNAP_set_fr(a,b,c) supfr_set_fr(a, b, c)
#define SNAP_set_rfr(a,b,c) supfr_set_rfr(a, b, c)
#define SNAP_set_fc(a,b,c) supfr_set_fc(a, b, c)
#define SNAP_set_rfc(a,b,c) supfr_set_rfc(a, b, c)
#define SNAP_set_coef(a,b,c) supfr_set_coef(a, b, c)
#define SNAP_set_coef_d(a,b,c) supfr_set_coef_d(a, b, c)
#define SNAP_set_str(a,b) supfr_set_str(a, b)
#define SNAP_set_str_real(a,b,c) supfr_set_str_real(a, b, c)
#define SNAP_set_str_imag(a,b,c) supfr_set_str_imag(a, b, c)
#define SNAP_set_str_ppnumber(a,b,c) supfr_set_str_ppnumber(a, b, c)
#define SNAP_set_str_number(a,b,c) supfr_set_str_number(a, b, c)
#define SNAP_set_str_num(a,b,c) supfr_set_str_num(a, b, c)
#define SNAP_set_str_term(a,b) supfr_set_str_term(a, b)
#define SNAP_set_str_ppmonomial(a,b,c) supfr_set_str_ppmonomial(a, b, c)
#define SNAP_set_str_monomial(a,b) supfr_set_str_monomial(a, b)
#define SNAP_set_str_poly(a,b) supfr_set_str_poly(a, b)
#define SNAP_set_str_polyall(a,b) supfr_set_str_polyall(a, b)
#define SNAP_swap supfr_swap
#define SNAP_2norm(a,b) supfr_2norm(a, b)
#define SNAP_self_neg(a) supfr_self_neg(a)
#define SNAP_self_reversal supfr_self_reversal
#define SNAP_add(a,b,c) supfr_add(a, b, c)
#define SNAP_sub(a,b,c) supfr_sub(a, b, c)
#define SNAP_mul(a,b,c) supfr_mul(a, b, c)
#define SNAP_mul_traditional_nc(a,b,c) supfr_mul_traditional_nc(a, b, c)
#define SNAP_mul_traditional(a,b,c) supfr_mul_traditional(a, b, c)
#define SNAP_mul_karatsuba_main(a,b,c,d,e,f,g,h,i,j,k,l,m,n) supfr_mul_karatsuba_main(a, b, c, d, e, f, g, h, i, j, k, l, m, n)
#define SNAP_mul_karatsuba_nc(a,b,c,d) supfr_mul_karatsuba_nc(a, b, c, d)
#define SNAP_mul_karatsuba(a,b,c) supfr_mul_karatsuba(a, b, c)
#define SNAP_mul_karatsuba_block_nc(a,b,c) supfr_mul_karatsuba_block_nc(a, b, c)
#define SNAP_mul_karatsuba_block(a,b,c) supfr_mul_karatsuba_block(a, b, c)
#define SNAP_mul_base(a,b,c) supfr_mul_fr(a, b, c)
#define SNAP_mul_basereal(a,b,c) supfr_mul_fr(a, b, c)
#define SNAP_mul_fr(a,b,c) supfr_mul_fr(a, b, c)
#define SNAP_mul_si(a,b,c) supfr_mul_si(a, b, c)
#define SNAP_mul_d(a,b,c) supfr_mul_d(a, b, c)
#define SNAP_mul_dc(a,b,c) supfr_mul_dc(a, b, c)
#define SNAP_div_qr_nc(a,b,c) supfr_div_qr_nc(a, b, c)
#define SNAP_div_qr(a,b,c,d) supfr_div_qr(a, b, c, d)
#define SNAP_lsdiv_q(a,b,c) supfr_lsdiv_q(a, b, c)
#define SNAP_fftdiv_q(a,b,c) supfr_fftdiv_q(a, b, c)
#define SNAP_div_base(a,b,c) supfr_div_fr(a, b, c)
#define SNAP_div_basereal(a,b,c) supfr_div_fr(a, b, c)
#define SNAP_div_fr(a,b,c) supfr_div_fr(a, b, c)
#define SNAP_div_fc(a,b,c) supfr_div_fc(a, b, c)
#define SNAP_div_d(a,b,c) supfr_div_d(a, b, c)
#define SNAP_div_dc(a,b,c) supfr_div_dc(a, b, c)
#define SNAP_randpoly(a,b,c,d,e) supfr_randpoly(a, b, c, d, e)

#define SNAP_agcd_exqrgcd_rootsquaring supfr_agcd_exqrgcd_rootsquaring
#define SNAP_agcd_exqrgcd_fft supfr_agcd_exqrgcd_fft
#define SNAP_agcd_exqrgcd_roughsplit supfr_agcd_exqrgcd_roughsplit
#define SNAP_agcd_exqrgcd_split supfr_agcd_exqrgcd_split
#define SNAP_agcd_exqrgcd_quicksort_uint_by_base_nc supfr_agcd_exqrgcd_quicksort_uint_by_mpfr_nc
#define SNAP_agcd_exqrgcd_quicksort_uint_by_base supfr_agcd_exqrgcd_quicksort_uint_by_mpfr
#define SNAP_agcd_exqrgcd_Qkthcolumn supfr_agcd_exqrgcd_Qkthcolumn
#define SNAP_agcd_exqrgcd supfr_agcd_exqrgcd
#define SNAP_agcd_exqrgcd_qrstep supfr_agcd_exqrgcd_qrstep

#define SNAP_agcd_qrgcd supfr_agcd_qrgcd
#define SNAP_agcd_qrgcd_qrstep supfr_agcd_qrgcd_qrstep

#define SNAP_agcd_uvgcd supfr_agcd_uvgcd
#define SNAP_agcd_uvgcd_iteration_7_3(a,b,c,d,e) supfr_agcd_uvgcd_iteration_7_3(a, b, c, d, e)
#define SNAP_agcd_uvgcd_solving_10_2(a,b,c,d,e,f) supfr_agcd_uvgcd_solving_10_2(a, b, c, d, e, f)
#define SNAP_agcd_uvgcd_update(a,b,c,d,e,f,g) supfr_agcd_uvgcd_update(a, b, c, d, e, f, g)
#define SNAP_agcd_uvgcd_iteration_9_2(a,b,c,d,e,f) supfr_agcd_uvgcd_iteration_9_2(a, b, c, d, e, f)
#define SNAP_agcd_uvgcd_ex supfr_agcd_uvgcd_ex

#define SNAPBASE_t mpfr_t
#define SNAPBASE_prec_t mpfr_prec_t
#define SNAPBASE_get_default_prec mpfr_get_default_prec
#define SNAPBASE_rnd_t mpfr_rnd_t
#define SNAPBASE_mpfr_rnd_t mpfr_rnd_t
#define SNAPBASE_mpc_rnd_t mpc_rnd_t
// #define SNAPBASE_RNDN MPFR_RNDN
#define SNAPBASE_const_pi(a) mpfr_const_pi(a, SNAPLIB_MPFR_RND)
#define SNAPBASE_init mpfr_init
#define SNAPBASE_clear mpfr_clear
#define SNAPBASE_init_set(a,b) mpfr_init_set(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASE_init_set_ui(a,b) mpfr_init_set_ui(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASE_init_set_d(a,b) mpfr_init_set_d(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASE_set(a,b) mpfr_set(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASE_set_ui(a,b) mpfr_set_ui(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASE_set_z(a,b) mpfr_set_z(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASE_set_fr(a,b) mpfr_set(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASE_set_fc(a,b) mpfr_set(a, mpc_realref(b), MPC_RND_RE(SNAPLIB_MPC_RND))
#define SNAPBASE_set_d(a,b) mpfr_set_d(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASE_set_dc(a,b) mpfr_set_d(a, creal(b), SNAPLIB_MPFR_RND)
#define SNAPBASE_set_str(a,b,c) mpfr_set_str(a, b, c, SNAPLIB_MPFR_RND)
// #define SNAPBASE_get_str(a,b,c) mpfr_get_str(a, b, c)
// We assume that round mode is ROUND TO THE NEAREST
#define SNAPBASE_get_d(a) mpfr_get_d(a, SNAPLIB_MPFR_RND)
#define SNAPBASE_get_ui_rnd(a) mpfr_get_ui(a, SNAPLIB_MPFR_RND)
#define SNAPBASE_sgn(a) mpfr_sgn(a)
#define SNAPBASE_zeroq(a) (mpfr_sgn(a) == 0)
#define SNAPBASE_nan_p(a) mpfr_nan_p(a)
#define SNAPBASE_abs(a,b) mpfr_abs(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASE_cmp(a,b) mpfr_cmp(a, b)
#define SNAPBASE_cmp_ui(a,b) mpfr_cmp_ui(a, b)
#define SNAPBASE_neg(a,b) mpfr_neg(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASE_swap(a,b) mpfr_swap(a, b)
#define SNAPBASE_add(a,b,c) mpfr_add(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASE_add_d(a,b,c) mpfr_add_d(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASE_sub(a,b,c) mpfr_sub(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASE_sub_d(a,b,c) mpfr_sub_d(a, b, c, SNAPLIB_MPFR_RND)
// #define SNAPBASE_addmul(a,b,c) N/A
#define SNAPBASE_mul(a,b,c) mpfr_mul(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASE_mul_ui(a,b,c) mpfr_mul_ui(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASE_mul_si(a,b,c) mpfr_mul_si(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASE_mul_d(a,b,c) mpfr_mul_d(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASE_mul_dc(a,b,c) mpfr_mul_d(a, b, creal(c), SNAPLIB_MPFR_RND)
#define SNAPBASE_mul_fr(a,b,c) mpfr_mul(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASE_div(a,b,c) mpfr_div(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASE_div_basereal(a,b,c) mpfr_div(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASE_div_fr(a,b,c) mpfr_div(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASE_div_fc(a,b,c) mpfr_div(a, b, mpc_realref(c), MPC_RND_RE(SNAPLIB_MPC_RND))
#define SNAPBASE_div_d(a,b,c) mpfr_div_d(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASE_div_dc(a,b,c) mpfr_div_d(a, b, creal(c), SNAPLIB_MPFR_RND)
#define SNAPBASE_div_ui(a,b,c) mpfr_div_ui(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASE_div_si(a,b,c) mpfr_div_si(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASE_sqrt(a,b) mpfr_sqrt(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASE_sqrt_ui(a,b) mpfr_sqrt_ui(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASE_exp2(a,b) mpfr_exp2(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASE_urandom(a,b) mpfr_urandom(a, b, SNAPLIB_MPFR_RND)

#define SNAPBASEREAL_t SNAPBASE_t
#define SNAPBASEREAL_prec_t SNAPBASE_prec_t
#define SNAPBASEREAL_get_default_prec SNAPBASE_get_default_prec
#define SNAPBASEREAL_rnd_t SNAPBASE_rnd_t
#define SNAPBASEREAL_mpfr_rnd_t SNAPBASE_mpfr_rnd_t
#define SNAPBASEREAL_RNDN SNAPBASE_RNDN
#define SNAPBASEREAL_const_pi SNAPBASE_const_pi
#define SNAPBASEREAL_init SNAPBASE_init
#define SNAPBASEREAL_clear SNAPBASE_clear
#define SNAPBASEREAL_init_set SNAPBASE_init_set
#define SNAPBASEREAL_init_set_ui SNAPBASE_init_set_ui
#define SNAPBASEREAL_init_set_d SNAPBASE_init_set_d
#define SNAPBASEREAL_set SNAPBASE_set
#define SNAPBASEREAL_set_ui SNAPBASE_set_ui
#define SNAPBASEREAL_set_z SNAPBASE_set_z
#define SNAPBASEREAL_set_fr SNAPBASE_set_fr
#define SNAPBASEREAL_set_d SNAPBASE_set_d
#define SNAPBASEREAL_set_dc SNAPBASE_set_dc
#define SNAPBASEREAL_set_str SNAPBASE_set_str
#define SNAPBASEREAL_get_d SNAPBASE_get_d
#define SNAPBASEREAL_get_ui_rnd SNAPBASE_get_ui_rnd
#define SNAPBASEREAL_sgn SNAPBASE_sgn
#define SNAPBASEREAL_zeroq SNAPBASE_zeroq
#define SNAPBASEREAL_nan_p SNAPBASE_nan_p
#define SNAPBASEREAL_abs SNAPBASE_abs
#define SNAPBASEREAL_cmp SNAPBASE_cmp
#define SNAPBASEREAL_cmp_ui SNAPBASE_cmp_ui
#define SNAPBASEREAL_neg SNAPBASE_neg
#define SNAPBASEREAL_swap SNAPBASE_swap
#define SNAPBASEREAL_add SNAPBASE_add
#define SNAPBASEREAL_add_d SNAPBASE_add_d
#define SNAPBASEREAL_sub SNAPBASE_sub
#define SNAPBASEREAL_sub_d SNAPBASE_sub_d
#define SNAPBASEREAL_mul SNAPBASE_mul
#define SNAPBASEREAL_mul_ui SNAPBASE_mul_ui
#define SNAPBASEREAL_mul_si SNAPBASE_mul_si
#define SNAPBASEREAL_mul_d SNAPBASE_mul_d
#define SNAPBASEREAL_mul_dc SNAPBASE_mul_dc
#define SNAPBASEREAL_mul_fr SNAPBASE_mul_fr
#define SNAPBASEREAL_div SNAPBASE_div
#define SNAPBASEREAL_div_fr SNAPBASE_div_fr
#define SNAPBASEREAL_div_fc SNAPBASE_div_fc
#define SNAPBASEREAL_div_d SNAPBASE_div_d
#define SNAPBASEREAL_div_dc SNAPBASE_div_dc
#define SNAPBASEREAL_div_ui SNAPBASE_div_ui
#define SNAPBASEREAL_div_si SNAPBASE_div_si
#define SNAPBASEREAL_sqrt SNAPBASE_sqrt
#define SNAPBASEREAL_sqrt_ui SNAPBASE_sqrt_ui
#define SNAPBASEREAL_exp2 SNAPBASE_exp2
#define SNAPBASEREAL_urandom SNAPBASE_urandom

#define SNAPBASECOMPLEX_t mpc_t
// #define SNAPBASECOMPLEX_RNDN MPC_RNDNN
#define SNAPBASECOMPLEX_init2(a,b) mpc_init2(a, b)
#define SNAPBASECOMPLEX_clear(a) mpc_clear(a)
#define SNAPBASECOMPLEX_init_set(a,b) mpc_init_set(a, b, SNAPLIB_MPC_RND)
#define SNAPBASECOMPLEX_init_set_ui(a,b) mpc_init_set_ui(a, b, SNAPLIB_MPC_RND)
#define SNAPBASECOMPLEX_init_set_si(a,b) mpc_init_set_si(a, b, SNAPLIB_MPC_RND)
#define SNAPBASECOMPLEX_set(a,b) mpc_set(a, b, SNAPLIB_MPC_RND)
#define SNAPBASECOMPLEX_set_ui(a,b) mpc_set_ui(a, b, SNAPLIB_MPC_RND)
#define SNAPBASECOMPLEX_set_base(a,b) mpc_set_fr(a, b, SNAPLIB_MPC_RND)
#define SNAPBASECOMPLEX_set_basecomplex(a,b) mpc_set(a, b, SNAPLIB_MPC_RND)
#define SNAPBASECOMPLEX_zeroq(a) (mpfr_sgn(mpc_realref(a)) == 0 && mpfr_sgn(mpc_imagref(a)) == 0)
#define SNAPBASECOMPLEX_add(a,b,c) mpc_add(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASECOMPLEX_sub(a,b,c) mpc_sub(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASECOMPLEX_mul(a,b,c) mpc_mul(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASECOMPLEX_mul_ui(a,b,c) mpc_mul_ui(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASECOMPLEX_div(a,b,c) mpc_div(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASECOMPLEX_div_ui(a,b,c) mpc_div_ui(a, b, c, SNAPLIB_MPC_RND)
#define SNAPBASECOMPLEX_exp(a,b) mpc_exp(a, b, SNAPLIB_MPC_RND)
#define SNAPBASECOMPLEX_realref(a) mpc_realref(a)
#define SNAPBASECOMPLEX_imagref(a) mpc_imagref(a)
#define SNAPBASECOMPLEX_neg(a,b) mpc_neg(a, b, SNAPLIB_MPC_RND)

#define SNAPMTX_t sdmfr_t
#define SNAPMTX_init sdmfr_init
#define SNAPMTX_init2 sdmfr_init2
#define SNAPMTX_reinit2 sdmfr_reinit2
#define SNAPMTX_reinit3 sdmfr_reinit3
#define SNAPMTX_realloc sdmfr_realloc
#define SNAPMTX_clear sdmfr_clear
#define SNAPMTX_swap sdmfr_swap
#define SNAPMTX_subresultant_mapping_matrix_asc(a,b,c,d) sdmfr_subresultant_mapping_matrix_asc(a, b, c, d)
#define SNAPMTX_subresultant_mapping_matrix_dsc(a,b,c,d) sdmfr_subresultant_mapping_matrix_dsc(a, b, c, d)
#define SNAPMTX_subresultant_mapping_matrix_transpose(a,b,c,d) sdmfr_subresultant_mapping_matrix_transpose(a, b, c, d)
#define SNAPMTX_subresultant_mapping_matrix_transpose_column_major(a,b,c,d) sdmfr_subresultant_mapping_matrix_transpose_column_major(a, b, c, d)
#define SNAPMTX_convolution_matrix(a,b,c) sdmfr_convolution_matrix(a, b, c)
#define SNAPMTX_convolution_matrix_column_major(a,b,c) sdmfr_convolution_matrix_column_major(a, b, c)
#define SNAPMTX_convolution_matrix_zerofill(a,b,c) sdmfr_convolution_matrix_zerofill(a, b, c)
#define SNAPMTX_sylvester_matrix_transpose(a,b,c) sdmfr_sylvester_matrix_transpose(a, b, c)
#define SNAPMTX_rows sdmfr_rows
#define SNAPMTX_rsize sdmfr_rsize
#define SNAPMTX_cols sdmfr_cols
#define SNAPMTX_csize sdmfr_csize
#define SNAPMTX_elem sdmfr_elem
#define SNAPMTX_elem_column_major sdmfr_elem_column_major
#define SNAPMTX_elems sdmfr_elems
#define SNAPMTX_elemp sdmfr_elemp
#define SNAPMTX_elemp_column_major sdmfr_elemp_column_major

#define SNAPMTXCOMPLEX_t sdmfc_t
#define SNAPMTXCOMPLEX_init sdmfc_init
#define SNAPMTXCOMPLEX_init2 sdmfc_init2
#define SNAPMTXCOMPLEX_reinit2 sdmfc_reinit2
#define SNAPMTXCOMPLEX_reinit3 sdmfc_reinit3
#define SNAPMTXCOMPLEX_realloc sdmfc_realloc
#define SNAPMTXCOMPLEX_clear sdmfc_clear
#define SNAPMTXCOMPLEX_swap sdmfc_swap
#define SNAPMTXCOMPLEX_subresultant_mapping_matrix_asc(a,b,c,d) sdmfc_subresultant_mapping_matrix_asc(a, b, c, d)
#define SNAPMTXCOMPLEX_subresultant_mapping_matrix_transpose(a,b,c,d) sdmfc_subresultant_mapping_matrix_transpose(a, b, c, d)
#define SNAPMTXCOMPLEX_subresultant_mapping_matrix_transpose_column_major(a,b,c,d) sdmfc_subresultant_mapping_matrix_transpose_column_major(a, b, c, d)
#define SNAPMTXCOMPLEX_convolution_matrix(a,b,c) sdmfc_convolution_matrix(a, b, c)
#define SNAPMTXCOMPLEX_convolution_matrix_conj(a,b,c) sdmfc_convolution_matrix_conj(a, b, c)
#define SNAPMTXCOMPLEX_convolution_matrix_column_major(a,b,c) sdmfc_convolution_matrix_column_major(a, b, c)
#define SNAPMTXCOMPLEX_convolution_matrix_zerofill(a,b,c) sdmfc_convolution_matrix_zerofill(a, b, c)
#define SNAPMTXCOMPLEX_convolution_matrix_zerofill_conj(a,b,c) sdmfc_convolution_matrix_zerofill_conj(a, b, c)
#define SNAPMTXCOMPLEX_sylvester_matrix_transpose(a,b,c) sdmfc_sylvester_matrix_transpose(a, b, c)
#define SNAPMTXCOMPLEX_rows sdmfc_rows
#define SNAPMTXCOMPLEX_rsize sdmfc_rsize
#define SNAPMTXCOMPLEX_cols sdmfc_cols
#define SNAPMTXCOMPLEX_csize sdmfc_csize
#define SNAPMTXCOMPLEX_elem sdmfc_elem
#define SNAPMTXCOMPLEX_elem_column_major sdmfc_elem_column_major
#define SNAPMTXCOMPLEX_elems sdmfc_elems
#define SNAPMTXCOMPLEX_elemp sdmfc_elemp
#define SNAPMTXCOMPLEX_elemp_column_major sdmfc_elemp_column_major

// compatiblity for BLAS and MBLAS
#define SNAPMTX_BLAS_nrm2(a,b,c,d) snap_mblas_frnrm2(a, b, c, d)
#define SNAPMTX_BLAS_dot(a,b,c,d,e,f) snap_mblas_frdot(a, b, c, d, e, f)
#define SNAPMTX_BLAS_dotc(a,b,c,d,e,f) snap_mblas_frdot(a, b, c, d, e, f)
