/*
 * Copyright (c) 2012-2015, Kosaku Nagasaka <nagasaka@main.h.kobe-u.ac.jp>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define SNAP_SUPZ_T

#define SNAP_t supz_t
#define SNAP_init supz_init
#define SNAP_init2 supz_init2
#define SNAP_init_set(a,b) supz_init_set(a, b)
#define SNAP_clear supz_clear
#define SNAP_coef supz_coef
#define SNAP_coefp supz_coefp
#define SNAP_coefs supz_coefs
#define SNAP_lcoef supz_lcoef
#define SNAP_lcoefp supz_lcoefp
#define SNAP_size supz_size
#define SNAP_degree supz_degree
#define SNAP_set(a,b) supz_set(a, b)
#define SNAP_set_z(a,b,c) supz_set_z(a, b, c)
#define SNAP_set_d(a,b,c) supz_set_d(a, b, c)
#define SNAP_set_rd(a,b,c) supz_set_rd(a, b, c)
#define SNAP_set_dc(a,b,c) supz_set_dc(a, b, c)
#define SNAP_set_rdc(a,b,c) supz_set_rdc(a, b, c)
#define SNAP_set_fr(a,b,c) supz_set_fr(a, b, c)
#define SNAP_set_rfr(a,b,c) supz_set_rfr(a, b, c)
#define SNAP_set_fc(a,b,c) supz_set_fc(a, b, c)
#define SNAP_set_rfc(a,b,c) supz_set_rfc(a, b, c)
#define SNAP_set_coef(a,b,c) supz_set_coef(a, b, c)
#define SNAP_set_coef_d(a,b,c) supz_set_coef_d(a, b, c)
#define SNAP_set_str(a,b) supz_set_str(a, b)
#define SNAP_set_str_real(a,b,c) supz_set_str_real(a, b, c)
#define SNAP_set_str_imag(a,b,c) supz_set_str_imag(a, b, c)
#define SNAP_set_str_ppnumber(a,b,c) supz_set_str_ppnumber(a, b, c)
#define SNAP_set_str_number(a,b,c) supz_set_str_number(a, b, c)
#define SNAP_set_str_num(a,b,c) supz_set_str_num(a, b, c)
#define SNAP_set_str_term(a,b) supz_set_str_term(a, b)
#define SNAP_set_str_ppmonomial(a,b,c) supz_set_str_ppmonomial(a, b, c)
#define SNAP_set_str_monomial(a,b) supz_set_str_monomial(a, b)
#define SNAP_set_str_poly(a,b) supz_set_str_poly(a, b)
#define SNAP_set_str_polyall(a,b) supz_set_str_polyall(a, b)
#define SNAP_swap supz_swap
#define SNAP_2norm(a,b) supz_2norm(a, b)
#define SNAP_self_neg(a) supz_self_neg(a)
#define SNAP_self_reversal supz_self_reversal
#define SNAP_add(a,b,c) supz_add(a, b, c)
#define SNAP_sub(a,b,c) supz_sub(a, b, c)
#define SNAP_mul_traditional_nc(a,b,c) supz_mul_traditional_nc(a, b, c)
#define SNAP_mul_traditional(a,b,c) supz_mul_traditional(a, b, c)
#define SNAP_mul_karatsuba_main(a,b,c,d,e,f,g,h,i,j,k,l,m,n) supz_mul_karatsuba_main(a, b, c, d, e, f, g, h, i, j, k, l, m, n)
#define SNAP_mul_karatsuba_nc(a,b,c,d) supz_mul_karatsuba_nc(a, b, c, d)
#define SNAP_mul_karatsuba(a,b,c) supz_mul_karatsuba(a, b, c)
#define SNAP_mul_karatsuba_block_nc(a,b,c) supz_mul_karatsuba_block_nc(a, b, c)
#define SNAP_mul_karatsuba_block(a,b,c) supz_mul_karatsuba_block(a, b, c)
#define SNAP_mul_fr(a,b,c) supz_mul_fr(a, b, c)
#define SNAP_mul_si(a,b,c) supz_mul_si(a, b, c)
#define SNAP_mul_d(a,b,c) supz_mul_d(a, b, c)
#define SNAP_mul_dc(a,b,c) supz_mul_dc(a, b, c)
// #define SNAP_div_qr_nc(a,b,c,d) supz_div_qr_nc(a, b, c)
// #define SNAP_div_qr(a,b,c,d,e) supz_div_qr(a, b, c, d)
// #define SNAP_lsdiv_q(a,b,c,d) supz_lsdiv_q(a, b, c, d)
#define SNAP_div_fr(a,b,c) supz_div_fr(a, b, c)
#define SNAP_div_fc(a,b,c) supz_div_fc(a, b, c)
#define SNAP_div_d(a,b,c) supz_div_d(a, b, c)
#define SNAP_div_dc(a,b,c) supz_div_dc(a, b, c)
#define SNAP_randpoly(a,b,c,d,e) supz_randpoly(a, b, c, d, e)

#define SNAPBASE_t mpz_t
// #define SNAPBASE_rnd_t mpfr_rnd_t
#define SNAPBASE_mpfr_rnd_t mpfr_rnd_t
#define SNAPBASE_mpc_rnd_t mpc_rnd_t
// #define SNAPBASE_RNDN MPFR_RNDN
#define SNAPBASE_init mpz_init
#define SNAPBASE_clear mpz_clear
#define SNAPBASE_init_set(a,b) mpz_init_set(a, b)
#define SNAPBASE_init_set_ui(a,b) mpz_init_set_ui(a, b)
#define SNAPBASE_set(a,b) mpz_set(a, b)
#define SNAPBASE_set_ui(a,b) mpz_set_ui(a, b)
#define SNAPBASE_set_z(a,b) mpz_set(a, b)
#define SNAPBASE_set_fr(a,b) mpfr_get_z(a, b, SNAPLIB_MPFR_RND)
#define SNAPBASE_set_fc(a,b) mpfr_get_z(a, mpc_realref(b), MPC_RND_RE(SNAPLIB_MPC_RND))
#define SNAPBASE_set_d(a,b) mpz_set_d(a, b)
#define SNAPBASE_set_dc(a,b) mpz_set_d(a, creal(b))
#define SNAPBASE_set_str(a,b,c) mpz_set_str(a, b, c)
#define SNAPBASE_get_str(a,b,c) mpz_get_str(a, b, c)
#define SNAPBASE_sgn(a) mpz_sgn(a)
#define SNAPBASE_zeroq(a) (mpz_sgn(a) == 0)
#define SNAPBASE_neg(a,b) mpz_neg(a, b)
#define SNAPBASE_swap(a,b) mpz_swap(a, b)
#define SNAPBASE_add(a,b,c) mpz_add(a, b, c)
#define SNAPBASE_add_ui(a,b,c) mpz_add_ui(a, b, c)
#define SNAPBASE_sub(a,b,c) mpz_sub(a, b, c)
#define SNAPBASE_addmul(a,b,c) mpz_addmul(a, b, c)
#define SNAPBASE_mul(a,b,c) mpz_mul(a, b, c)
#define SNAPBASE_mul_ui(a,b,c) mpz_mul_ui(a, b, c)
#define SNAPBASE_mul_si(a,b,c) mpz_mul_si(a, b, c)
#define SNAPBASE_mul_fr(a,b,c) mpz_mul_fr(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASE_mul_d(a,b,c) mpz_mul_d(a, b, c)
#define SNAPBASE_mul_dc(a,b,c) mpz_mul_d(a, b, creal(c))
// #define SNAPBASE_div(a,b,c,d) mpz_div(a, b, c)
#define SNAPBASE_div_fr(a,b,c) mpz_div_fr(a, b, c, SNAPLIB_MPFR_RND)
#define SNAPBASE_div_fc(a,b,c) mpz_div_fr(a, b, mpc_realref(c), MPC_RND_RE(SNAPLIB_MPC_RND))
#define SNAPBASE_div_d(a,b,c) mpz_div_d(a, b, c)
#define SNAPBASE_div_dc(a,b,c) mpz_div_d(a, b, creal(c))
// #define SNAPBASE_sqrt(a,b,c) mpfr_sqrt(a, b, c)
#define SNAPBASE_urandom(a,b,c) mpz_urandomm(a, b, c)

#define SNAPMTX_t sdmz_t
#define SNAPMTX_init sdmz_init
#define SNAPMTX_init2 sdmz_init2
#define SNAPMTX_reinit2 sdmz_reinit2
#define SNAPMTX_reinit3 sdmz_reinit3
#define SNAPMTX_realloc sdmz_realloc
#define SNAPMTX_clear sdmz_clear
#define SNAPMTX_swap sdmz_swap
#define SNAPMTX_subresultant_mapping_matrix_asc(a,b,c,d) sdmz_subresultant_mapping_matrix_asc(a, b, c, d)
#define SNAPMTX_subresultant_mapping_matrix_dsc(a,b,c,d) sdmz_subresultant_mapping_matrix_dsc(a, b, c, d)
#define SNAPMTX_subresultant_mapping_matrix_transpose(a,b,c,d) sdmz_subresultant_mapping_matrix_transpose(a, b, c, d)
#define SNAPMTX_subresultant_mapping_matrix_transpose_column_major(a,b,c,d) sdmz_subresultant_mapping_matrix_transpose_column_major(a, b, c, d)
#define SNAPMTX_convolution_matrix(a,b,c) sdmz_convolution_matrix(a, b, c)
#define SNAPMTX_convolution_matrix_column_major(a,b,c) sdmz_convolution_matrix_column_major(a, b, c)
#define SNAPMTX_convolution_matrix_zerofill(a,b,c) sdmz_convolution_matrix_zerofill(a, b, c)
#define SNAPMTX_sylvester_matrix_transpose(a,b,c) sdmz_sylvester_matrix_transpose(a, b, c)
#define SNAPMTX_rows sdmz_rows
#define SNAPMTX_rsize sdmz_rsize
#define SNAPMTX_cols sdmz_cols
#define SNAPMTX_csize sdmz_csize
#define SNAPMTX_elem sdmz_elem
#define SNAPMTX_elem_column_major sdmz_elem_column_major
#define SNAPMTX_elems sdmz_elems
#define SNAPMTX_elemp sdmz_elemp
#define SNAPMTX_elemp_column_major sdmz_elemp_column_major
